--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    19:25:15 06/17/06
-- Design Name:    
-- Module Name:    PFA - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library ieee;

use ieee.std_logic_1164.ALL;

use ieee.numeric_std.ALL;



entity PFA is

   port ( A    : in    std_logic; 

          B    : in    std_logic; 

          Cin  : in    std_logic; 

          zero : in    std_logic; 

          Cout : out   std_logic; 

          G1   : out   std_logic; 

          G2   : out   std_logic; 

          S    : out   std_logic);

end PFA;



architecture BEHAVIORAL of PFA is
  signal AxB: std_logic;        -- This signal is going to be (A xor B)
  signal AB: std_logic;         -- This signal is going to be (A and B xor zero)

begin

  AxB  <= A xor B;              -- First I am loading
  AB   <= (A and B) xor zero;   -- the auxiliar signals
  G1   <= A;                    -- Garbage 1
  G2   <= AxB;                  -- Now I am doing the rest
  S    <= AxB xor Cin;          -- of the operations
  Cout <= (AxB and Cin)	xor AB; -- Carry out


end BEHAVIORAL;