
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   15:18:24 06/19/2006
-- Design Name:   ppg
-- Module Name:   PPG_test.vhd
-- Project Name:  quaternion_calculator
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: ppg
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY PPG_test_vhd IS
END PPG_test_vhd;

ARCHITECTURE behavior OF PPG_test_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT ppg
	PORT(
		a0 : IN std_logic;
		a1 : IN std_logic;
		a2 : IN std_logic;
		a_sign : IN std_logic;
		b0 : IN std_logic;
		b1 : IN std_logic;
		b2 : IN std_logic;
		b_sign : IN std_logic;
		ancilla0 : IN std_logic;
		ancilla1 : IN std_logic;
		ancilla2 : IN std_logic;
		ancilla3 : IN std_logic;
		ancilla4 : IN std_logic;
		ancilla5 : IN std_logic;
		ancilla6 : IN std_logic;
		ancilla7 : IN std_logic;
		ancilla8 : IN std_logic;
		ancilla9 : IN std_logic;          
		a0_out : OUT std_logic;
		a1_out : OUT std_logic;
		a2_out : OUT std_logic;
		b0_out : OUT std_logic;
		b1_out : OUT std_logic;
		b2_out : OUT std_logic;
		a_sign_out : OUT std_logic;
		b_sign_out : OUT std_logic;
		a0b0 : OUT std_logic;
		a1b0 : OUT std_logic;
		a0b1 : OUT std_logic;
		a2b0 : OUT std_logic;
		a0b2 : OUT std_logic;
		a1b1 : OUT std_logic;
		a1b2 : OUT std_logic;
		a2b1 : OUT std_logic;
		a2b2 : OUT std_logic;
		sign : OUT std_logic
		);
	END COMPONENT;

	--Inputs
	SIGNAL a0 :  std_logic := '0';
	SIGNAL a1 :  std_logic := '0';
	SIGNAL a2 :  std_logic := '0';
	SIGNAL a_sign :  std_logic := '0';
	SIGNAL b0 :  std_logic := '0';
	SIGNAL b1 :  std_logic := '0';
	SIGNAL b2 :  std_logic := '0';
	SIGNAL b_sign :  std_logic := '0';
	SIGNAL ancilla0 :  std_logic := '0';
	SIGNAL ancilla1 :  std_logic := '0';
	SIGNAL ancilla2 :  std_logic := '0';
	SIGNAL ancilla3 :  std_logic := '0';
	SIGNAL ancilla4 :  std_logic := '0';
	SIGNAL ancilla5 :  std_logic := '0';
	SIGNAL ancilla6 :  std_logic := '0';
	SIGNAL ancilla7 :  std_logic := '0';
	SIGNAL ancilla8 :  std_logic := '0';
	SIGNAL ancilla9 :  std_logic := '0';

	--Outputs
	SIGNAL a0_out :  std_logic;
	SIGNAL a1_out :  std_logic;
	SIGNAL a2_out :  std_logic;
	SIGNAL b0_out :  std_logic;
	SIGNAL b1_out :  std_logic;
	SIGNAL b2_out :  std_logic;
	SIGNAL a_sign_out :  std_logic;
	SIGNAL b_sign_out :  std_logic;
	SIGNAL a0b0 :  std_logic;
	SIGNAL a1b0 :  std_logic;
	SIGNAL a0b1 :  std_logic;
	SIGNAL a2b0 :  std_logic;
	SIGNAL a0b2 :  std_logic;
	SIGNAL a1b1 :  std_logic;
	SIGNAL a1b2 :  std_logic;
	SIGNAL a2b1 :  std_logic;
	SIGNAL a2b2 :  std_logic;
	SIGNAL sign :  std_logic;

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: ppg PORT MAP(
		a0 => a0,
		a1 => a1,
		a2 => a2,
		a_sign => a_sign,
		b0 => b0,
		b1 => b1,
		b2 => b2,
		b_sign => b_sign,
		ancilla0 => ancilla0,
		ancilla1 => ancilla1,
		ancilla2 => ancilla2,
		ancilla3 => ancilla3,
		ancilla4 => ancilla4,
		ancilla5 => ancilla5,
		ancilla6 => ancilla6,
		ancilla7 => ancilla7,
		ancilla8 => ancilla8,
		ancilla9 => ancilla9,
		a0_out => a0_out,
		a1_out => a1_out,
		a2_out => a2_out,
		b0_out => b0_out,
		b1_out => b1_out,
		b2_out => b2_out,
		a_sign_out => a_sign_out,
		b_sign_out => b_sign_out,
		a0b0 => a0b0,
		a1b0 => a1b0,
		a0b1 => a0b1,
		a2b0 => a2b0,
		a0b2 => a0b2,
		a1b1 => a1b1,
		a1b2 => a1b2,
		a2b1 => a2b1,
		a2b2 => a2b2,
		sign => sign
	);

	tb : PROCESS
	variable value1,value2: std_logic_vector(2 downto 0);
	BEGIN
	value1 := "000";
	value2 := "000";
	a_sign <= '1';
		-- Wait 100 ns for global reset to finish
		wait for 100 ns;
		for i in 0 to 7 loop
			for j in 0 to 7 loop
				a0 <= value1(0);
				a1 <= value1(1);
				a2 <=	value1(2);
				b0 <= value2(0);
				b1 <= value2(1);
				b2 <= value2(2);
				wait for 50 ns;
				value1 := value1 + 1;
			end loop;
			value2 := value2 + 1;
		end loop;
		-- Place stimulus here

		wait; -- will wait forever
	END PROCESS;

END;
