--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    11:00:40 06/19/06
-- Design Name:    
-- Module Name:    Peres - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Peres is
    Port ( A_input1 : in std_logic;
           B_input2 : in std_logic;
           C_ancilla : in std_logic;
           P_garbage : out std_logic;
           Q_result : out std_logic;
           R_carryout : out std_logic);
end Peres;

--						 _____________
--				   	 |           |
--	 (input1) in -->|A          |
--						 |          P|--> out	 = A
--	(ancilla) in -->|C  Peres   |
--						 |			   Q|--> out	 =	A xor B	(result)
--	 (input2) in -->|B          |
--						 |     R     |
--						 |___________|
--								 |
--								 |
--								 V out	 = AB xor C	 (carry out)




architecture Behavioral of Peres is

begin

P_garbage <= A_input1;
Q_result <= A_input1 xor B_input2;
R_carryout <= (A_input1 and B_input2) xor C_ancilla;

end Behavioral;
