----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:01:17 06/18/2006 
-- Design Name: 
-- Module Name:    TWOsIN - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity TWOsIN_7 is
    Port ( 
           P_M_1 : in  STD_LOGIC;  -- Plus=0, Minus=1 (Local Sign +/-)
           P_M_2 : in  STD_LOGIC;  -- Plus=0, Minus=1 (Global Sign +/-)
           I : in  STD_LOGIC_VECTOR (6 downto 0);  --input 
           Z1 : in STD_LOGIC;
			  Z2 : in STD_LOGIC;
			  Z3 : in STD_LOGIC;
			  Z4 : in STD_LOGIC;
			  Z5 : in STD_LOGIC;
			  O : out STD_LOGIC_VECTOR (6 downto 0);  --output
           Sign  : out  STD_LOGIC; --output MSB
           G1 : out STD_LOGIC;
			  G2 : out STD_LOGIC;
			  G3 : out STD_LOGIC;
			  G4 : out STD_LOGIC;
			  G5 : out STD_LOGIC;			  
			  G  : out  STD_LOGIC);--Garbage bit
end TWOsIN_7;

architecture Behavioral of TWOsIN_7 is

component OR_rev
	port (  a : in std_logic;
           b : in std_logic;
           Z : in std_logic;           -- ancilla
			  a_out : out std_logic;
			  b_out : out std_logic;
			  result : out std_logic			  
			  );
end component;

 signal XSigns: STD_LOGIC;
 signal a1,a2,a3,a4,a5,b1,b2,b3,b4,b5: std_logic;
 signal TOR: STD_LOGIC_VECTOR (5 downto 0); 
begin

--     process(I, P_M_1, P_M_2, TOR)
--      begin
       XSigns <= P_M_1 xor P_M_2; -- Final sign
	   Sign   <= XSigns;
       G      <= P_M_2;  -- Global sign for the full vector
       TOR(0) <= I(0);
       O(0)   <= TOR(0); -- LSB always without modifications

OR_1: OR_rev
port map (  a => I(1),
				b => TOR(0),
				Z => Z1,
				a_out => a1,
				b_out => b1,
				result => TOR(1));
G1 <= a1 xor b1;
O(1) <= I(1) xor (XSigns and TOR(0));
        
OR_2: OR_rev
port map (  a => I(2),
				b => TOR(1),
				Z => Z2,
				a_out => a2,
				b_out => b2,
				result => TOR(2));
G2 <= a2 xor b2;
O(2) <= I(2) xor (XSigns and TOR(1));		  

OR_3: OR_rev
port map (  a => I(3),
				b => TOR(2),
				Z => Z3,
				a_out => a3,
				b_out => b3,
				result => TOR(3));
G3 <= a3 xor b3;
O(3) <= I(3) xor (XSigns and TOR(2));

OR_4: OR_rev
port map (  a => I(4),
				b => TOR(3),
				Z => Z4,
				a_out => a4,
				b_out => b4,
				result => TOR(4));
G4 <= a4 xor b4;
O(4) <= I(4) xor (XSigns and TOR(3));

OR_5: OR_rev
port map (  a => I(5),
				b => TOR(4),
				Z => Z5,
				a_out => a5,
				b_out => b5,
				result => TOR(5));
G5 <= a5 xor b5;
O(5) <= I(5) xor (XSigns and TOR(4));


-- i changed the code below to the above, because there's an OR in here,..
-- so i created a reversible(?) OR component..		  
		  --for n in 1 to 5 loop
        -- TOR(n) <= I(n) or TOR(n-1);        
        -- O(n)<= I(n) xor (XSigns and TOR(n-1));
        --end loop;
       O(6) <= I(6) xor (XSigns and TOR(5)); -- do NOT generate last gate TOR6
--     end process;
     
end Behavioral;

