----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:01:17 06/18/2006 
-- Design Name: 
-- Module Name:    TWOsIN - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity TWOsIN is
    Port ( 
           P_M_1 : in  STD_LOGIC;  -- Plus=0, Minus=1 (Local Sign +/-)
           P_M_2 : in  STD_LOGIC;  -- Plus=0, Minus=1 (Global Sign +/-)
           I : in  STD_LOGIC_VECTOR (6 downto 0);  --input 
           O : out STD_LOGIC_VECTOR (6 downto 0);  --output
           Sign  : out  STD_LOGIC; --output MSB
           G     : out  STD_LOGIC);--Garbage bit
end TWOsIN;

architecture Behavioral of TWOsIN is
 signal XSigns: STD_LOGIC;
 signal TOR: STD_LOGIC_VECTOR (5 downto 0); 
begin

     process(I, P_M_1, P_M_2, TOR)
      begin
       XSigns <= P_M_1 xor P_M_2; -- Final sign
	   Sign   <= XSigns;
       G      <= P_M_2;  -- Global sign for the full vector
       TOR(0) <= I(0);
       O(0)   <= TOR(0); -- LSB always without modifications
        for n in 1 to 5 loop
         TOR(n) <= I(n) or TOR(n-1);        
         O(n)<= I(n) xor (XSigns and TOR(n-1));
        end loop;
       O(6) <= I(6) xor (XSigns and TOR(5)); -- do NOT generate last gate TOR6
     end process;
     
end Behavioral;

