----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:08:13 06/18/2006 
-- Design Name: 
-- Module Name:    TWOsOUT - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity TWOsOUT is
    Port ( P_M : in  STD_LOGIC; --Plus=0, Minus=1
           I   : in  STD_LOGIC_VECTOR (7 downto 0);
           O   : out STD_LOGIC_VECTOR (7 downto 0);
           Sign: out STD_LOGIC);
end TWOsOUT;

architecture Behavioral of TWOsOUT is
 signal TOR: STD_LOGIC_VECTOR (6 downto 0);
begin
     process(I, P_M, TOR)
       begin
       Sign   <= P_M;
       TOR(0) <= I(0);
       O(0)   <= TOR(0); -- LSB always without modifications
        for n in 1 to 6 loop
         TOR(n) <= I(n) or TOR(n-1);        
         O(n)<= I(n) xor (P_M and TOR(n-1));
        end loop;
       O(7) <= I(7) xor (P_M and TOR(6)); -- do NOT generate last gate TOR7
     end process;

end Behavioral;

