--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    21:34:45 06/19/06
-- Design Name:    
-- Module Name:    addsub3 - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity addsub3 is
Port ( 	  Ain: in std_logic_vector (6 downto 0);
	 		  --Ain0 : in std_logic;
           --Ain1 : in std_logic;
           --Ain2 : in std_logic;
			  --Ain3 : in std_logic;
           --Ain4 : in std_logic;
           --Ain5 : in std_logic;
			  --Ain6 : in std_logic;
           SignFractialA : in std_logic;
           SignVectorA : in std_logic;
           Bin: in std_logic_vector (6 downto 0);
			  --Bin0 : in std_logic;
           --Bin1 : in std_logic;
           --Bin2 : in std_logic;
			  --Bin3 : in std_logic;
           --Bin4 : in std_logic;
           --Bin5 : in std_logic;
			  --Bin6 : in std_logic;
           SignFractialB : in std_logic;
           SignVectorB : in std_logic;
           Z1 : in std_logic;
           Z2 : in std_logic;
           Z3 : in std_logic;
           Z4 : in std_logic;
			  Z5 : in std_logic;
           Z6 : in std_logic;
			  Z7 : in std_logic;
			  Z8 : in std_logic;
			  TWOsIN1_Z1 : in std_logic;
			  TWOsIN1_Z2 : in std_logic;
			  TWOsIN1_Z3 : in std_logic;
			  TWOsIN1_Z4 : in std_logic;
			  TWOsIN1_Z5 : in std_logic;
			  TWOsIN2_Z1 : in std_logic;
			  TWOsIN2_Z2 : in std_logic;
			  TWOsIN2_Z3 : in std_logic;
			  TWOsIN2_Z4 : in std_logic;
			  TWOsIN2_Z5 : in std_logic;
			  TWOsOUT_Z1 : in std_logic;
			  TWOsOUT_Z2 : in std_logic;
			  TWOsOUT_Z3 : in std_logic;
			  TWOsOUT_Z4 : in std_logic;
			  TWOsOUT_Z5 : in std_logic;
			  TWOsOUT_Z6 : in std_logic;
			  G1 : out std_logic;
			  G2 : out std_logic;
			  G3 : out std_logic;
			  G4 : out std_logic;
			  G5 : out std_logic;
			  G6 : out std_logic;
			  G7 : out std_logic;
			  G8 : out std_logic;
			  G9 : out std_logic;
			  G10: out std_logic;
			  G11: out std_logic;
			  G12: out std_logic;
			  G13: out std_logic;
			  G14: out std_logic;
			  TWOsIN1_G1 : out std_logic;
			  TWOsIN1_G2 : out std_logic;
			  TWOsIN1_G3 : out std_logic;
			  TWOsIN1_G4 : out std_logic;
			  TWOsIN1_G5 : out std_logic;
			  TWOsIN1_G : out std_logic;
			  TWOsIN2_G1 : out std_logic;
			  TWOsIN2_G2 : out std_logic;
			  TWOsIN2_G3 : out std_logic;
			  TWOsIN2_G4 : out std_logic;
			  TWOsIN2_G5 : out std_logic;
			  TWOsIN2_G : out std_logic;
			  TWOsOUT_G1 : out std_logic;
			  TWOsOUT_G2 : out std_logic;
			  TWOsOUT_G3 : out std_logic;
			  TWOsOUT_G4 : out std_logic;
			  TWOsOUT_G5 : out std_logic;
			  TWOsOUT_G6 : out std_logic;
			  TWOsOUT_G : out std_logic;
			  AddResult: out std_logic_vector (7 downto 0);
			  --AddResult0 : out std_logic;
			  --AddResult1 : out std_logic;
			  --AddResult2 : out std_logic;
			  --AddResult3 : out std_logic;
			  --AddResult4 : out std_logic;
			  --AddResult5 : out std_logic;
			  --AddResult6 : out std_logic;
			  --AddResult7 : out std_logic;
			  SignVectorQ: out std_logic);
end addsub3;

architecture Behavioral of addsub3 is

component TWOsIN_7								-- two's complement on the input (defined in twosin.vhd)
    Port ( 
           P_M_1 : in  STD_LOGIC;  -- Plus=0, Minus=1 (Local Sign +/-)
           P_M_2 : in  STD_LOGIC;  -- Plus=0, Minus=1 (Global Sign +/-)
           I : in  STD_LOGIC_VECTOR (6 downto 0);  --input 
           Z1 : in STD_LOGIC;
			  Z2 : in STD_LOGIC;
			  Z3 : in STD_LOGIC;
			  Z4 : in STD_LOGIC;
			  Z5 : in STD_LOGIC;
			  O : out STD_LOGIC_VECTOR (6 downto 0);  --output
           Sign  : out  STD_LOGIC; --output MSB
           G1 : out STD_LOGIC;
			  G2 : out STD_LOGIC;
			  G3 : out STD_LOGIC;
			  G4 : out STD_LOGIC;
			  G5 : out STD_LOGIC;			  
			  G  : out  STD_LOGIC);--Garbage bit
end component;

component TWOsOUT_8								-- two's complement on the output (defined in twosout.vhd)
    Port ( 
           P_M : in  STD_LOGIC;  -- Plus=0, Minus=1 
           I : in  STD_LOGIC_VECTOR (7 downto 0);  --input 
           Z1 : in STD_LOGIC;
			  Z2 : in STD_LOGIC;
			  Z3 : in STD_LOGIC;
			  Z4 : in STD_LOGIC;
			  Z5 : in STD_LOGIC;
			  Z6 : in STD_LOGIC;
			  O : out STD_LOGIC_VECTOR (7 downto 0);  --output
           Sign  : out  STD_LOGIC; --output MSB
           G1 : out STD_LOGIC;
			  G2 : out STD_LOGIC;
			  G3 : out STD_LOGIC;
			  G4 : out STD_LOGIC;
			  G5 : out STD_LOGIC;
			  G6 : out STD_LOGIC;			  
			  G  : out  STD_LOGIC);--Garbage bit
end component;

component Peres
    Port ( A_input1 : in std_logic;
           B_input2 : in std_logic;
           C_ancilla : in std_logic;
           P_garbage : out std_logic;
           Q_result : out std_logic;
           R_carryout : out std_logic);
end component;

component PFA									-- Peres Full Adder component (defined in PFA.vhd)
      port ( Cin  : in    std_logic; 
             A    : in    std_logic; 
             B    : in    std_logic; 
             zero : in    std_logic; 
             G1   : out   std_logic; 
             G2   : out   std_logic; 
             S    : out   std_logic; 
             Cout : out   std_logic);
end component;

signal outputA_0,outputA_1,outputA_2,outputA_3,outputA_4,outputA_5,outputA_6: std_logic;
signal outputB_0,outputB_1,outputB_2,outputB_3,outputB_4,outputB_5,outputB_6: std_logic;
signal signA,signB: std_logic;
signal garbA,garbB: std_logic;
signal intermediate_xor: std_logic;
signal intermediate_xor2: std_logic;
signal c1,c2,c3,c4,c5,c6,c7: std_logic;							-- intermediate Carry Out from PFAs

begin

A_2scomplement: TWOsIN_7
	port map ( I=>Ain,
				  P_M_1=>SignFractialA,
				  P_M_2=>SignVectorA,
				  Z1=>TWOsIN1_Z1,
				  Z2=>TWOsIN1_Z2,
				  Z3=>TWOsIN1_Z3,
				  Z4=>TWOsIN1_Z4,
				  Z5=>TWOsIN1_Z5,
				  O(0)=>outputA_0,
				  O(1)=>outputA_1,
				  O(2)=>outputA_2,
				  O(3)=>outputA_3,
				  O(4)=>outputA_4,
				  O(5)=>outputA_5,
				  O(6)=>outputA_6,
				  Sign=>signA,
				  G1=>TWOsIN1_G1,
				  G2=>TWOsIN1_G2,
				  G3=>TWOsIN1_G3,
				  G4=>TWOsIN1_G4,
				  G5=>TWOsIN1_G5,
				  G=>TWOsIN1_G);

B_2scomplement: TWOsIN_7
	port map ( I=>Bin,
				  P_M_1=>SignFractialB,
				  P_M_2=>SignVectorB,
				  Z1=>TWOsIN2_Z1,
				  Z2=>TWOsIN2_Z2,
				  Z3=>TWOsIN2_Z3,
				  Z4=>TWOsIN2_Z4,
				  Z5=>TWOsIN2_Z5,
				  O(0)=>outputB_0,
				  O(1)=>outputB_1,
				  O(2)=>outputB_2,
				  O(3)=>outputB_3,
				  O(4)=>outputB_4,
				  O(5)=>outputB_5,
				  O(6)=>outputB_6,
				  Sign=>signB,
				  G1=>TWOsIN2_G1,
				  G2=>TWOsIN2_G2,
				  G3=>TWOsIN2_G3,
				  G4=>TWOsIN2_G4,
				  G5=>TWOsIN2_G5,
				  G=>TWOsIN2_G);

--Output0_add: PFA
--	port map ( Cin=>Z1,
--				  A=>outputA_0,
--				  B=>outputB_0,
--				  zero=>Z2,
--				  G1=>G1,
--				  G2=>G2,
--				  --S=>S1,
--				  S=>AddResult(0),
--				  Cout=>c1);

Output0_add: Peres
	port map ( 
				  A_input1=>outputA_0,
				  B_input2=>outputB_0,
				  C_ancilla=>Z2,				-- Z1 is not used
				  P_garbage => G1,			-- G2 is not used
				  --S=>S1,
				  Q_result=>AddResult(0),
				  R_carryout=>c1);

Output1_add: PFA
	port map ( Cin=>c1,
				  A=>outputA_1,
				  B=>outputB_1,
				  zero=>Z3,
				  G1=>G3,
				  G2=>G4,
				  --S=>S2,
				  S=>AddResult(1),
				  Cout=>c2);

Output2_add: PFA
	port map ( Cin=>c2,
				  A=>outputA_2,
				  B=>outputB_2,
				  zero=>Z4,
				  G1=>G5,
				  G2=>G6,
				  --S=>S3,
				  S=>AddResult(2),
				  --Cout=>AddResult(3));
				  Cout=>c3);

Output3_add: PFA
	port map ( Cin=>c3,
				  A=>outputA_3,
				  B=>outputB_3,
				  zero=>Z5,
				  G1=>G7,
				  G2=>G8,
				  --S=>S3,
				  S=>AddResult(3),
				  Cout=>c4);

Output4_add: PFA
	port map ( Cin=>c4,
				  A=>outputA_4,
				  B=>outputB_4,
				  zero=>Z6,
				  G1=>G9,
				  G2=>G10,
				  --S=>S3,
				  S=>AddResult(4),
				  Cout=>c5);

Output5_add: PFA
	port map ( Cin=>c5,
				  A=>outputA_5,
				  B=>outputB_5,
				  zero=>Z7,
				  G1=>G11,
				  G2=>G12,
				  --S=>S3,
				  S=>AddResult(5),
				  Cout=>c6);

Output6_add: PFA
	port map ( Cin=>c6,
				  A=>outputA_6,
				  B=>outputB_6,
				  zero=>Z8,
				  G1=>G13,
				  G2=>G14,
				  --S=>S3,
				  S=>AddResult(6),
				  Cout=>c7);

intermediate_xor <= signA xor signB;
SignVectorQ<= intermediate_xor xor c7;
G2 <= signB;
AddResult(7) <= c7;

end Behavioral;
