--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    21:33:08 06/19/06
-- Design Name:    
-- Module Name:    multiplier_quat3 - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity multiplier_quat3 is

port ( aw : in std_logic_vector (2 downto 0);
		 aw_sign : in std_logic;
		 ax : in std_logic_vector (2 downto 0);
		 ax_sign : in std_logic;
		 ay : in std_logic_vector (2 downto 0);
		 ay_sign : in std_logic;
		 az : in std_logic_vector (2 downto 0);
		 az_sign : in std_logic;
		 bw : in std_logic_vector (2 downto 0);
		 bw_sign : in std_logic;
		 bx : in std_logic_vector (2 downto 0);
		 bx_sign : in std_logic;
		 by : in std_logic_vector (2 downto 0);
		 by_sign : in std_logic;
		 bz : in std_logic_vector (2 downto 0);
		 bz_sign : in std_logic;
		 tpm_ancilla : in std_logic_vector (0 to 255);
		 addsub_Z : in std_logic_vector (1 to 96);
		 addsub_twosin1_Z : in std_logic_vector (1 to 60);
		 addsub_twosin2_Z : in std_logic_vector (1 to 60);
		 addsub_twosout_Z : in std_logic_vector (1 to 72);
		 --addsub_vectorA : in std_logic;		  -- ??
		 --addsub_vectorB : in std_logic;		  -- ??
		 aw_out : out std_logic_vector (2 downto 0);
		 aw_sign_out : out std_logic;
		 ax_out : out std_logic_vector (2 downto 0);
		 ax_sign_out : out std_logic;
		 ay_out : out std_logic_vector (2 downto 0);
		 ay_sign_out : out std_logic;
		 az_out : out std_logic_vector (2 downto 0);
		 az_sign_out : out std_logic;
		 bw_out : out std_logic_vector (2 downto 0);
		 bw_sign_out : out std_logic;
		 bx_out : out std_logic_vector (2 downto 0);
		 bx_sign_out : out std_logic;
		 by_out : out std_logic_vector (2 downto 0);
		 by_sign_out : out std_logic;
		 bz_out : out std_logic_vector (2 downto 0);
		 bz_sign_out : out std_logic;		 
		 w : out std_logic_vector (7 downto 0);
		 w_sign : out std_logic;
		 x : out std_logic_vector (7 downto 0);
		 x_sign : out std_logic;
		 y : out std_logic_vector (7 downto 0);
		 y_sign : out std_logic;
		 z : out std_logic_vector (7 downto 0);
		 z_sign : out std_logic;
		 tpm_G : out std_logic_vector (0 to 143);
		 tpm_ab_out: out std_logic_vector (1 to 128);
		 addsub_G : out std_logic_vector	(1 to 224);
		 addsub_twosin1_G : out std_logic_vector (1 to 72);
		 addsub_twosin2_G : out std_logic_vector (1 to 72);
		 addsub_twosout_G : out std_logic_vector (1 to 84)
	--  to test the result from the TPM multiplication, activate the following outputs and deactivate the corresponding signals
	--	 awbw : out std_logic_vector (5 downto 0);
	--	 awbw_sign : out std_logic;
	--	 awbx : out std_logic_vector (5 downto 0);
	--	 awbx_sign : out std_logic;
	--	 awby : out std_logic_vector (5 downto 0);
	--	 awby_sign : out std_logic;
	--	 awbz : out std_logic_vector (5 downto 0);
	--	 awbz_sign : out std_logic;
	--	 axbw : out std_logic_vector (5 downto 0);
	--	 axbw_sign : out std_logic;
	--	 axbx : out std_logic_vector (5 downto 0);
	--	 axbx_sign : out std_logic;
	--	 axby : out std_logic_vector (5 downto 0);
	--	 axby_sign : out std_logic;
	--	 axbz : out std_logic_vector (5 downto 0);
	--	 axbz_sign : out std_logic;
	--	 aybw : out std_logic_vector (5 downto 0);
	--	 aybw_sign : out std_logic;
	--	 aybx : out std_logic_vector (5 downto 0);
	--	 aybx_sign : out std_logic;
	--	 ayby : out std_logic_vector (5 downto 0);
	--	 ayby_sign : out std_logic;
	--	 aybz : out std_logic_vector (5 downto 0);
	--	 aybz_sign : out std_logic;
	--	 azbw : out std_logic_vector (5 downto 0);
	--	 azbw_sign : out std_logic;
	--	 azbx : out std_logic_vector (5 downto 0);
	--	 azbx_sign : out std_logic;
	--	 azby : out std_logic_vector (5 downto 0);
	--	 azby_sign : out std_logic;
	--	 azbz : out std_logic_vector (5 downto 0);
	--	 azbz_sign : out std_logic
		 );
end multiplier_quat3;

architecture Behavioral of multiplier_quat3 is

component TPM						 
    Port ( mul_a0 : in std_logic;
           mul_a1 : in std_logic;
           mul_a2 : in std_logic;
			  mul_a_sign : in std_logic;
			  mul_b0 : in std_logic;
           mul_b1 : in std_logic;
           mul_b2 : in std_logic;
			  mul_b_sign : in std_logic;
           mul_ancilla0 : in std_logic;
           mul_ancilla1 : in std_logic;
           mul_ancilla2 : in std_logic;
           mul_ancilla3 : in std_logic;
           mul_ancilla4 : in std_logic;
           mul_ancilla5 : in std_logic;
           mul_ancilla6 : in std_logic;
           mul_ancilla7 : in std_logic;
           mul_ancilla8 : in std_logic;
           mul_ancilla9 : in std_logic;
           mul_ancilla10 : in std_logic;
           mul_ancilla11 : in std_logic;
           mul_ancilla12 : in std_logic;
           mul_ancilla13 : in std_logic;
           mul_ancilla14 : in std_logic;
           mul_ancilla15 : in std_logic;
           mul_a0_out : out std_logic;
           mul_a1_out : out std_logic;
           mul_a2_out : out std_logic;
           mul_a_sign_out : out std_logic;
           mul_b0_out : out std_logic;
           mul_b1_out : out std_logic;
           mul_b2_out : out std_logic;
           mul_b_sign_out : out std_logic;
           mul_result0 : out std_logic;
           mul_result1 : out std_logic;
           mul_result2 : out std_logic;
           mul_result3 : out std_logic;
           mul_result4 : out std_logic;
           mul_result5 : out std_logic;
           mul_g0 : out std_logic;
           mul_g1 : out std_logic;
           mul_g2 : out std_logic;
           mul_g3 : out std_logic;
           mul_g4 : out std_logic;
           mul_g5 : out std_logic;
           mul_g6 : out std_logic;
           mul_g7 : out std_logic;
           mul_g8 : out std_logic;
           mul_sign_out : out std_logic);
end component;

component addsub3
Port ( 	  Ain: in std_logic_vector (6 downto 0);
           SignFractialA : in std_logic;
           SignVectorA : in std_logic;
           Bin: in std_logic_vector (6 downto 0);
           SignFractialB : in std_logic;
           SignVectorB : in std_logic;
           Z1 : in std_logic;
           Z2 : in std_logic;
           Z3 : in std_logic;
           Z4 : in std_logic;
			  Z5 : in std_logic;
           Z6 : in std_logic;
			  Z7 : in std_logic;
			  Z8 : in std_logic;
			  TWOsIN1_Z1 : in std_logic;
			  TWOsIN1_Z2 : in std_logic;
			  TWOsIN1_Z3 : in std_logic;
			  TWOsIN1_Z4 : in std_logic;
			  TWOsIN1_Z5 : in std_logic;
			  TWOsIN2_Z1 : in std_logic;
			  TWOsIN2_Z2 : in std_logic;
			  TWOsIN2_Z3 : in std_logic;
			  TWOsIN2_Z4 : in std_logic;
			  TWOsIN2_Z5 : in std_logic;
			  TWOsOUT_Z1 : in std_logic;
			  TWOsOUT_Z2 : in std_logic;
			  TWOsOUT_Z3 : in std_logic;
			  TWOsOUT_Z4 : in std_logic;
			  TWOsOUT_Z5 : in std_logic;
			  TWOsOUT_Z6 : in std_logic;
			  G1 : out std_logic;
			  G2 : out std_logic;
			  G3 : out std_logic;
			  G4 : out std_logic;
			  G5 : out std_logic;
			  G6 : out std_logic;
			  G7 : out std_logic;
			  G8 : out std_logic;
			  G9 : out std_logic;
			  G10: out std_logic;
			  G11: out std_logic;
			  G12: out std_logic;
			  G13: out std_logic;
			  G14: out std_logic;
			  TWOsIN1_G1 : out std_logic;
			  TWOsIN1_G2 : out std_logic;
			  TWOsIN1_G3 : out std_logic;
			  TWOsIN1_G4 : out std_logic;
			  TWOsIN1_G5 : out std_logic;
			  TWOsIN1_G : out std_logic;
			  TWOsIN2_G1 : out std_logic;
			  TWOsIN2_G2 : out std_logic;
			  TWOsIN2_G3 : out std_logic;
			  TWOsIN2_G4 : out std_logic;
			  TWOsIN2_G5 : out std_logic;
			  TWOsIN2_G : out std_logic;
			  TWOsOUT_G1 : out std_logic;
			  TWOsOUT_G2 : out std_logic;
			  TWOsOUT_G3 : out std_logic;
			  TWOsOUT_G4 : out std_logic;
			  TWOsOUT_G5 : out std_logic;
			  TWOsOUT_G6 : out std_logic;
			  TWOsOUT_G : out std_logic;
			  AddResult: out std_logic_vector (7 downto 0);
			  SignVectorQ: out std_logic);
end component;

-- to test the results of the TPM, deactivate the signals below, and activate the corresponding outputs in the port list
signal awbw,awbx,awby,awbz,axbw,axbx,axby,axbz,aybw,aybx,ayby,aybz,azbw,azbx,azby,azbz: std_logic_vector (5 downto 0);
signal awbw_sign,awbx_sign,awby_sign,awbz_sign: std_logic;
signal axbw_sign,axbx_sign,axby_sign,axbz_sign: std_logic;
signal aybw_sign,aybx_sign,ayby_sign,aybz_sign: std_logic;
signal azbw_sign,azbx_sign,azby_sign,azbz_sign: std_logic;

-- the follwing are signals from/to addsub3.  Don't deactivate these when testing TPM
signal awbw_min_axbx_result: std_logic_vector (6 downto 0);
signal awbw_min_axbx_result_sign: std_logic;
signal ayby_plus_azbz_result: std_logic_vector (6 downto 0);
signal ayby_plus_azbz_result_sign: std_logic;
signal awbx_plus_axbw_result: std_logic_vector (6 downto 0);
signal awbx_plus_axbw_result_sign: std_logic;
signal aybz_min_azby_result: std_logic_vector (6 downto 0);
signal aybz_min_azby_result_sign: std_logic;
signal awby_plus_aybw_result: std_logic_vector (6 downto 0);
signal awby_plus_aybw_result_sign: std_logic;
signal azbx_min_axbz_result: std_logic_vector (6 downto 0);
signal azbx_min_axbz_result_sign: std_logic;
signal awbz_plus_azbw_result: std_logic_vector (6 downto 0);
signal awbz_plus_azbw_result_sign: std_logic;
signal axby_min_aybx_result: std_logic_vector (6 downto 0);
signal axby_min_aybx_result_sign: std_logic;
signal zero: std_logic;

begin
zero <= '0';

multiply_aw_bw: TPM
port map ( mul_a0 => aw(0),
           mul_a1 => aw(1),
           mul_a2 => aw(2),
			  mul_a_sign => aw_sign,
			  mul_b0 => bw(0),
           mul_b1 => bw(1),
           mul_b2 => bw(2),
			  mul_b_sign => bw_sign,
           mul_ancilla0 => tpm_ancilla(0),
           mul_ancilla1 => tpm_ancilla(1),
           mul_ancilla2 => tpm_ancilla(2),
           mul_ancilla3 => tpm_ancilla(3),
           mul_ancilla4 => tpm_ancilla(4),
           mul_ancilla5 => tpm_ancilla(5),
           mul_ancilla6 => tpm_ancilla(6),
           mul_ancilla7 => tpm_ancilla(7),
           mul_ancilla8 => tpm_ancilla(8),
           mul_ancilla9 => tpm_ancilla(9),
           mul_ancilla10 => tpm_ancilla(10),
           mul_ancilla11 => tpm_ancilla(11),
           mul_ancilla12 => tpm_ancilla(12),
           mul_ancilla13 => tpm_ancilla(13),
           mul_ancilla14 => tpm_ancilla(14),
           mul_ancilla15 => tpm_ancilla(15),
           mul_a0_out => tpm_ab_out(1),
           mul_a1_out => tpm_ab_out(2),
           mul_a2_out => tpm_ab_out(3),
           mul_a_sign_out => tpm_ab_out(4),
           mul_b0_out => tpm_ab_out(5),
           mul_b1_out => tpm_ab_out(6),
           mul_b2_out => tpm_ab_out(7),
           mul_b_sign_out => tpm_ab_out(8),
           mul_result0 => awbw(0),
           mul_result1 => awbw(1),
           mul_result2 => awbw(2),
           mul_result3 => awbw(3),
           mul_result4 => awbw(4),
           mul_result5 => awbw(5),
           mul_g0 => tpm_G(0),
           mul_g1 => tpm_G(1),
           mul_g2 => tpm_G(2),
           mul_g3 => tpm_G(3),
           mul_g4 => tpm_G(4),
           mul_g5 => tpm_G(5),
           mul_g6 => tpm_G(6),
           mul_g7 => tpm_G(7),
           mul_g8 => tpm_G(8),
           mul_sign_out => awbw_sign);

multiply_aw_bx: TPM
port map ( mul_a0 => aw(0),
           mul_a1 => aw(1),
           mul_a2 => aw(2),
			  mul_a_sign => aw_sign,
			  mul_b0 => bx(0),
           mul_b1 => bx(1),
           mul_b2 => bx(2),
			  mul_b_sign => bx_sign,
           mul_ancilla0 => tpm_ancilla(16),
           mul_ancilla1 => tpm_ancilla(17),
           mul_ancilla2 => tpm_ancilla(18),
           mul_ancilla3 => tpm_ancilla(19),
           mul_ancilla4 => tpm_ancilla(20),
           mul_ancilla5 => tpm_ancilla(21),
           mul_ancilla6 => tpm_ancilla(22),
           mul_ancilla7 => tpm_ancilla(23),
           mul_ancilla8 => tpm_ancilla(24),
           mul_ancilla9 => tpm_ancilla(25),
           mul_ancilla10 => tpm_ancilla(26),
           mul_ancilla11 => tpm_ancilla(27),
           mul_ancilla12 => tpm_ancilla(28),
           mul_ancilla13 => tpm_ancilla(29),
           mul_ancilla14 => tpm_ancilla(30),
           mul_ancilla15 => tpm_ancilla(31),
           mul_a0_out => tpm_ab_out(9),
           mul_a1_out => tpm_ab_out(10),
           mul_a2_out => tpm_ab_out(11),
           mul_a_sign_out => tpm_ab_out(12),
           mul_b0_out => tpm_ab_out(13),
           mul_b1_out => tpm_ab_out(14),
           mul_b2_out => tpm_ab_out(15),
           mul_b_sign_out => tpm_ab_out(16),
           mul_result0 => awbx(0),
           mul_result1 => awbx(1),
           mul_result2 => awbx(2),
           mul_result3 => awbx(3),
           mul_result4 => awbx(4),
           mul_result5 => awbx(5),
           mul_g0 => tpm_G(9),
           mul_g1 => tpm_G(10),
           mul_g2 => tpm_G(11),
           mul_g3 => tpm_G(12),
           mul_g4 => tpm_G(13),
           mul_g5 => tpm_G(14),
           mul_g6 => tpm_G(15),
           mul_g7 => tpm_G(16),
           mul_g8 => tpm_G(17),
           mul_sign_out => awbx_sign);

multiply_aw_by: TPM
port map ( mul_a0 => aw(0),
           mul_a1 => aw(1),
           mul_a2 => aw(2),
			  mul_a_sign => aw_sign,
			  mul_b0 => by(0),
           mul_b1 => by(1),
           mul_b2 => by(2),
			  mul_b_sign => by_sign,
           mul_ancilla0 => tpm_ancilla(32),
           mul_ancilla1 => tpm_ancilla(33),
           mul_ancilla2 => tpm_ancilla(34),
           mul_ancilla3 => tpm_ancilla(35),
           mul_ancilla4 => tpm_ancilla(36),
           mul_ancilla5 => tpm_ancilla(37),
           mul_ancilla6 => tpm_ancilla(38),
           mul_ancilla7 => tpm_ancilla(39),
           mul_ancilla8 => tpm_ancilla(40),
           mul_ancilla9 => tpm_ancilla(41),
           mul_ancilla10 => tpm_ancilla(42),
           mul_ancilla11 => tpm_ancilla(43),
           mul_ancilla12 => tpm_ancilla(44),
           mul_ancilla13 => tpm_ancilla(45),
           mul_ancilla14 => tpm_ancilla(46),
           mul_ancilla15 => tpm_ancilla(47),
           mul_a0_out => tpm_ab_out(17),
           mul_a1_out => tpm_ab_out(18),
           mul_a2_out => tpm_ab_out(19),
           mul_a_sign_out => tpm_ab_out(20),
           mul_b0_out => tpm_ab_out(21),
           mul_b1_out => tpm_ab_out(22),
           mul_b2_out => tpm_ab_out(23),
           mul_b_sign_out => tpm_ab_out(24),
           mul_result0 => awby(0),
           mul_result1 => awby(1),
           mul_result2 => awby(2),
           mul_result3 => awby(3),
           mul_result4 => awby(4),
           mul_result5 => awby(5),
           mul_g0 => tpm_G(18),
           mul_g1 => tpm_G(19),
           mul_g2 => tpm_G(20),
           mul_g3 => tpm_G(21),
           mul_g4 => tpm_G(22),
           mul_g5 => tpm_G(23),
           mul_g6 => tpm_G(24),
           mul_g7 => tpm_G(25),
           mul_g8 => tpm_G(26),
           mul_sign_out => awby_sign);

multiply_aw_bz: TPM
port map ( mul_a0 => aw(0),
           mul_a1 => aw(1),
           mul_a2 => aw(2),
			  mul_a_sign => aw_sign,
			  mul_b0 => bz(0),
           mul_b1 => bz(1),
           mul_b2 => bz(2),
			  mul_b_sign => bz_sign,
           mul_ancilla0 => tpm_ancilla(48),
           mul_ancilla1 => tpm_ancilla(49),
           mul_ancilla2 => tpm_ancilla(50),
           mul_ancilla3 => tpm_ancilla(51),
           mul_ancilla4 => tpm_ancilla(52),
           mul_ancilla5 => tpm_ancilla(53),
           mul_ancilla6 => tpm_ancilla(54),
           mul_ancilla7 => tpm_ancilla(55),
           mul_ancilla8 => tpm_ancilla(56),
           mul_ancilla9 => tpm_ancilla(57),
           mul_ancilla10 => tpm_ancilla(58),
           mul_ancilla11 => tpm_ancilla(59),
           mul_ancilla12 => tpm_ancilla(60),
           mul_ancilla13 => tpm_ancilla(61),
           mul_ancilla14 => tpm_ancilla(62),
           mul_ancilla15 => tpm_ancilla(63),
           mul_a0_out => tpm_ab_out(25),
           mul_a1_out => tpm_ab_out(26),
           mul_a2_out => tpm_ab_out(27),
           mul_a_sign_out => tpm_ab_out(28),
           mul_b0_out => tpm_ab_out(29),
           mul_b1_out => tpm_ab_out(30),
           mul_b2_out => tpm_ab_out(31),
           mul_b_sign_out => tpm_ab_out(32),
           mul_result0 => awbz(0),
           mul_result1 => awbz(1),
           mul_result2 => awbz(2),
           mul_result3 => awbz(3),
           mul_result4 => awbz(4),
           mul_result5 => awbz(5),
           mul_g0 => tpm_G(27),
           mul_g1 => tpm_G(28),
           mul_g2 => tpm_G(29),
           mul_g3 => tpm_G(30),
           mul_g4 => tpm_G(31),
           mul_g5 => tpm_G(32),
           mul_g6 => tpm_G(33),
           mul_g7 => tpm_G(34),
           mul_g8 => tpm_G(35),
           mul_sign_out => awbz_sign);

multiply_ax_bw: TPM
port map ( mul_a0 => ax(0),
           mul_a1 => ax(1),
           mul_a2 => ax(2),
			  mul_a_sign => ax_sign,
			  mul_b0 => bw(0),
           mul_b1 => bw(1),
           mul_b2 => bw(2),
			  mul_b_sign => bw_sign,
           mul_ancilla0 => tpm_ancilla(64),
           mul_ancilla1 => tpm_ancilla(65),
           mul_ancilla2 => tpm_ancilla(66),
           mul_ancilla3 => tpm_ancilla(67),
           mul_ancilla4 => tpm_ancilla(68),
           mul_ancilla5 => tpm_ancilla(69),
           mul_ancilla6 => tpm_ancilla(70),
           mul_ancilla7 => tpm_ancilla(71),
           mul_ancilla8 => tpm_ancilla(72),
           mul_ancilla9 => tpm_ancilla(73),
           mul_ancilla10 => tpm_ancilla(74),
           mul_ancilla11 => tpm_ancilla(75),
           mul_ancilla12 => tpm_ancilla(76),
           mul_ancilla13 => tpm_ancilla(77),
           mul_ancilla14 => tpm_ancilla(78),
           mul_ancilla15 => tpm_ancilla(79),
           mul_a0_out => tpm_ab_out(33),
           mul_a1_out => tpm_ab_out(34),
           mul_a2_out => tpm_ab_out(35),
           mul_a_sign_out => tpm_ab_out(36),
           mul_b0_out => tpm_ab_out(37),
           mul_b1_out => tpm_ab_out(38),
           mul_b2_out => tpm_ab_out(39),
           mul_b_sign_out => tpm_ab_out(40),
           mul_result0 => axbw(0),
           mul_result1 => axbw(1),
           mul_result2 => axbw(2),
           mul_result3 => axbw(3),
           mul_result4 => axbw(4),
           mul_result5 => axbw(5),
           mul_g0 => tpm_G(36),
           mul_g1 => tpm_G(37),
           mul_g2 => tpm_G(38),
           mul_g3 => tpm_G(39),
           mul_g4 => tpm_G(40),
           mul_g5 => tpm_G(41),
           mul_g6 => tpm_G(42),
           mul_g7 => tpm_G(43),
           mul_g8 => tpm_G(44),
           mul_sign_out => axbw_sign);

multiply_ax_bx: TPM
port map ( mul_a0 => ax(0),
           mul_a1 => ax(1),
           mul_a2 => ax(2),
			  mul_a_sign => ax_sign,
			  mul_b0 => bx(0),
           mul_b1 => bx(1),
           mul_b2 => bx(2),
			  mul_b_sign => bx_sign,
           mul_ancilla0 => tpm_ancilla(80),
           mul_ancilla1 => tpm_ancilla(81),
           mul_ancilla2 => tpm_ancilla(82),
           mul_ancilla3 => tpm_ancilla(83),
           mul_ancilla4 => tpm_ancilla(84),
           mul_ancilla5 => tpm_ancilla(85),
           mul_ancilla6 => tpm_ancilla(86),
           mul_ancilla7 => tpm_ancilla(87),
           mul_ancilla8 => tpm_ancilla(88),
           mul_ancilla9 => tpm_ancilla(89),
           mul_ancilla10 => tpm_ancilla(90),
           mul_ancilla11 => tpm_ancilla(91),
           mul_ancilla12 => tpm_ancilla(92),
           mul_ancilla13 => tpm_ancilla(93),
           mul_ancilla14 => tpm_ancilla(94),
           mul_ancilla15 => tpm_ancilla(95),
           mul_a0_out => tpm_ab_out(41),
           mul_a1_out => tpm_ab_out(42),
           mul_a2_out => tpm_ab_out(43),
           mul_a_sign_out => tpm_ab_out(44),
           mul_b0_out => tpm_ab_out(45),
           mul_b1_out => tpm_ab_out(46),
           mul_b2_out => tpm_ab_out(47),
           mul_b_sign_out => tpm_ab_out(48),
           mul_result0 => axbx(0),
           mul_result1 => axbx(1),
           mul_result2 => axbx(2),
           mul_result3 => axbx(3),
           mul_result4 => axbx(4),
           mul_result5 => axbx(5),
           mul_g0 => tpm_G(45),
           mul_g1 => tpm_G(46),
           mul_g2 => tpm_G(47),
           mul_g3 => tpm_G(48),
           mul_g4 => tpm_G(49),
           mul_g5 => tpm_G(50),
           mul_g6 => tpm_G(51),
           mul_g7 => tpm_G(52),
           mul_g8 => tpm_G(53),
           mul_sign_out => axbx_sign);

multiply_ax_by: TPM
port map ( mul_a0 => ax(0),
           mul_a1 => ax(1),
           mul_a2 => ax(2),
			  mul_a_sign => ax_sign,
			  mul_b0 => by(0),
           mul_b1 => by(1),
           mul_b2 => by(2),
			  mul_b_sign => by_sign,
           mul_ancilla0 => tpm_ancilla(96),
           mul_ancilla1 => tpm_ancilla(97),
           mul_ancilla2 => tpm_ancilla(98),
           mul_ancilla3 => tpm_ancilla(99),
           mul_ancilla4 => tpm_ancilla(100),
           mul_ancilla5 => tpm_ancilla(101),
           mul_ancilla6 => tpm_ancilla(102),
           mul_ancilla7 => tpm_ancilla(103),
           mul_ancilla8 => tpm_ancilla(104),
           mul_ancilla9 => tpm_ancilla(105),
           mul_ancilla10 => tpm_ancilla(106),
           mul_ancilla11 => tpm_ancilla(107),
           mul_ancilla12 => tpm_ancilla(108),
           mul_ancilla13 => tpm_ancilla(109),
           mul_ancilla14 => tpm_ancilla(110),
           mul_ancilla15 => tpm_ancilla(111),
           mul_a0_out => tpm_ab_out(49),
           mul_a1_out => tpm_ab_out(50),
           mul_a2_out => tpm_ab_out(51),
           mul_a_sign_out => tpm_ab_out(52),
           mul_b0_out => tpm_ab_out(53),
           mul_b1_out => tpm_ab_out(54),
           mul_b2_out => tpm_ab_out(55),
           mul_b_sign_out => tpm_ab_out(56),
           mul_result0 => axby(0),
           mul_result1 => axby(1),
           mul_result2 => axby(2),
           mul_result3 => axby(3),
           mul_result4 => axby(4),
           mul_result5 => axby(5),
           mul_g0 => tpm_G(54),
           mul_g1 => tpm_G(55),
           mul_g2 => tpm_G(56),
           mul_g3 => tpm_G(57),
           mul_g4 => tpm_G(58),
           mul_g5 => tpm_G(59),
           mul_g6 => tpm_G(60),
           mul_g7 => tpm_G(61),
           mul_g8 => tpm_G(62),
           mul_sign_out => axby_sign);

multiply_ax_bz: TPM
port map ( mul_a0 => ax(0),
           mul_a1 => ax(1),
           mul_a2 => ax(2),
			  mul_a_sign => ax_sign,
			  mul_b0 => bz(0),
           mul_b1 => bz(1),
           mul_b2 => bz(2),
			  mul_b_sign => bz_sign,
           mul_ancilla0 => tpm_ancilla(112),
           mul_ancilla1 => tpm_ancilla(113),
           mul_ancilla2 => tpm_ancilla(114),
           mul_ancilla3 => tpm_ancilla(115),
           mul_ancilla4 => tpm_ancilla(116),
           mul_ancilla5 => tpm_ancilla(117),
           mul_ancilla6 => tpm_ancilla(118),
           mul_ancilla7 => tpm_ancilla(119),
           mul_ancilla8 => tpm_ancilla(120),
           mul_ancilla9 => tpm_ancilla(121),
           mul_ancilla10 => tpm_ancilla(122),
           mul_ancilla11 => tpm_ancilla(123),
           mul_ancilla12 => tpm_ancilla(124),
           mul_ancilla13 => tpm_ancilla(125),
           mul_ancilla14 => tpm_ancilla(126),
           mul_ancilla15 => tpm_ancilla(127),
           mul_a0_out => tpm_ab_out(57),
           mul_a1_out => tpm_ab_out(58),
           mul_a2_out => tpm_ab_out(59),
           mul_a_sign_out => tpm_ab_out(60),
           mul_b0_out => tpm_ab_out(61),
           mul_b1_out => tpm_ab_out(62),
           mul_b2_out => tpm_ab_out(63),
           mul_b_sign_out => tpm_ab_out(64),
           mul_result0 => axbz(0),
           mul_result1 => axbz(1),
           mul_result2 => axbz(2),
           mul_result3 => axbz(3),
           mul_result4 => axbz(4),
           mul_result5 => axbz(5),
           mul_g0 => tpm_G(63),
           mul_g1 => tpm_G(64),
           mul_g2 => tpm_G(65),
           mul_g3 => tpm_G(66),
           mul_g4 => tpm_G(67),
           mul_g5 => tpm_G(68),
           mul_g6 => tpm_G(69),
           mul_g7 => tpm_G(70),
           mul_g8 => tpm_G(71),
           mul_sign_out => axbz_sign);

multiply_ay_bw: TPM
port map ( mul_a0 => ay(0),
           mul_a1 => ay(1),
           mul_a2 => ay(2),
			  mul_a_sign => ay_sign,
			  mul_b0 => bw(0),
           mul_b1 => bw(1),
           mul_b2 => bw(2),
			  mul_b_sign => bw_sign,
           mul_ancilla0 => tpm_ancilla(128),
           mul_ancilla1 => tpm_ancilla(129),
           mul_ancilla2 => tpm_ancilla(130),
           mul_ancilla3 => tpm_ancilla(131),
           mul_ancilla4 => tpm_ancilla(132),
           mul_ancilla5 => tpm_ancilla(133),
           mul_ancilla6 => tpm_ancilla(134),
           mul_ancilla7 => tpm_ancilla(135),
           mul_ancilla8 => tpm_ancilla(136),
           mul_ancilla9 => tpm_ancilla(137),
           mul_ancilla10 => tpm_ancilla(138),
           mul_ancilla11 => tpm_ancilla(139),
           mul_ancilla12 => tpm_ancilla(140),
           mul_ancilla13 => tpm_ancilla(141),
           mul_ancilla14 => tpm_ancilla(142),
           mul_ancilla15 => tpm_ancilla(143),
           mul_a0_out => tpm_ab_out(65),
           mul_a1_out => tpm_ab_out(66),
           mul_a2_out => tpm_ab_out(67),
           mul_a_sign_out => tpm_ab_out(68),
           mul_b0_out => tpm_ab_out(69),
           mul_b1_out => tpm_ab_out(70),
           mul_b2_out => tpm_ab_out(71),
           mul_b_sign_out => tpm_ab_out(72),
           mul_result0 => aybw(0),
           mul_result1 => aybw(1),
           mul_result2 => aybw(2),
           mul_result3 => aybw(3),
           mul_result4 => aybw(4),
           mul_result5 => aybw(5),
           mul_g0 => tpm_G(72),
           mul_g1 => tpm_G(73),
           mul_g2 => tpm_G(74),
           mul_g3 => tpm_G(75),
           mul_g4 => tpm_G(76),
           mul_g5 => tpm_G(77),
           mul_g6 => tpm_G(78),
           mul_g7 => tpm_G(79),
           mul_g8 => tpm_G(80),
           mul_sign_out => aybw_sign);

multiply_ay_bx: TPM
port map ( mul_a0 => ay(0),
           mul_a1 => ay(1),
           mul_a2 => ay(2),
			  mul_a_sign => ay_sign,
			  mul_b0 => bx(0),
           mul_b1 => bx(1),
           mul_b2 => bx(2),
			  mul_b_sign => bx_sign,
           mul_ancilla0 => tpm_ancilla(144),
           mul_ancilla1 => tpm_ancilla(145),
           mul_ancilla2 => tpm_ancilla(146),
           mul_ancilla3 => tpm_ancilla(147),
           mul_ancilla4 => tpm_ancilla(148),
           mul_ancilla5 => tpm_ancilla(149),
           mul_ancilla6 => tpm_ancilla(150),
           mul_ancilla7 => tpm_ancilla(151),
           mul_ancilla8 => tpm_ancilla(152),
           mul_ancilla9 => tpm_ancilla(153),
           mul_ancilla10 => tpm_ancilla(154),
           mul_ancilla11 => tpm_ancilla(155),
           mul_ancilla12 => tpm_ancilla(156),
           mul_ancilla13 => tpm_ancilla(157),
           mul_ancilla14 => tpm_ancilla(158),
           mul_ancilla15 => tpm_ancilla(159),
           mul_a0_out => tpm_ab_out(73),
           mul_a1_out => tpm_ab_out(74),
           mul_a2_out => tpm_ab_out(75),
           mul_a_sign_out => tpm_ab_out(76),
           mul_b0_out => tpm_ab_out(77),
           mul_b1_out => tpm_ab_out(78),
           mul_b2_out => tpm_ab_out(79),
           mul_b_sign_out => tpm_ab_out(80),
           mul_result0 => aybx(0),
           mul_result1 => aybx(1),
           mul_result2 => aybx(2),
           mul_result3 => aybx(3),
           mul_result4 => aybx(4),
           mul_result5 => aybx(5),
           mul_g0 => tpm_G(81),
           mul_g1 => tpm_G(82),
           mul_g2 => tpm_G(83),
           mul_g3 => tpm_G(84),
           mul_g4 => tpm_G(85),
           mul_g5 => tpm_G(86),
           mul_g6 => tpm_G(87),
           mul_g7 => tpm_G(88),
           mul_g8 => tpm_G(89),
           mul_sign_out => aybx_sign);

multiply_ay_by: TPM
port map ( mul_a0 => ay(0),
           mul_a1 => ay(1),
           mul_a2 => ay(2),
			  mul_a_sign => ay_sign,
			  mul_b0 => by(0),
           mul_b1 => by(1),
           mul_b2 => by(2),
			  mul_b_sign => by_sign,
           mul_ancilla0 => tpm_ancilla(160),
           mul_ancilla1 => tpm_ancilla(161),
           mul_ancilla2 => tpm_ancilla(162),
           mul_ancilla3 => tpm_ancilla(163),
           mul_ancilla4 => tpm_ancilla(164),
           mul_ancilla5 => tpm_ancilla(165),
           mul_ancilla6 => tpm_ancilla(166),
           mul_ancilla7 => tpm_ancilla(167),
           mul_ancilla8 => tpm_ancilla(168),
           mul_ancilla9 => tpm_ancilla(169),
           mul_ancilla10 => tpm_ancilla(170),
           mul_ancilla11 => tpm_ancilla(171),
           mul_ancilla12 => tpm_ancilla(172),
           mul_ancilla13 => tpm_ancilla(173),
           mul_ancilla14 => tpm_ancilla(174),
           mul_ancilla15 => tpm_ancilla(175),
           mul_a0_out => tpm_ab_out(81),
           mul_a1_out => tpm_ab_out(82),
           mul_a2_out => tpm_ab_out(83),
           mul_a_sign_out => tpm_ab_out(84),
           mul_b0_out => tpm_ab_out(85),
           mul_b1_out => tpm_ab_out(86),
           mul_b2_out => tpm_ab_out(87),
           mul_b_sign_out => tpm_ab_out(88),
           mul_result0 => ayby(0),
           mul_result1 => ayby(1),
           mul_result2 => ayby(2),
           mul_result3 => ayby(3),
           mul_result4 => ayby(4),
           mul_result5 => ayby(5),
           mul_g0 => tpm_G(90),
           mul_g1 => tpm_G(91),
           mul_g2 => tpm_G(92),
           mul_g3 => tpm_G(93),
           mul_g4 => tpm_G(94),
           mul_g5 => tpm_G(95),
           mul_g6 => tpm_G(96),
           mul_g7 => tpm_G(97),
           mul_g8 => tpm_G(98),
           mul_sign_out => ayby_sign);

multiply_ay_bz: TPM
port map ( mul_a0 => ay(0),
           mul_a1 => ay(1),
           mul_a2 => ay(2),
			  mul_a_sign => ay_sign,
			  mul_b0 => bz(0),
           mul_b1 => bz(1),
           mul_b2 => bz(2),
			  mul_b_sign => bz_sign,
           mul_ancilla0 => tpm_ancilla(176),
           mul_ancilla1 => tpm_ancilla(177),
           mul_ancilla2 => tpm_ancilla(178),
           mul_ancilla3 => tpm_ancilla(179),
           mul_ancilla4 => tpm_ancilla(180),
           mul_ancilla5 => tpm_ancilla(181),
           mul_ancilla6 => tpm_ancilla(182),
           mul_ancilla7 => tpm_ancilla(183),
           mul_ancilla8 => tpm_ancilla(184),
           mul_ancilla9 => tpm_ancilla(185),
           mul_ancilla10 => tpm_ancilla(186),
           mul_ancilla11 => tpm_ancilla(187),
           mul_ancilla12 => tpm_ancilla(188),
           mul_ancilla13 => tpm_ancilla(189),
           mul_ancilla14 => tpm_ancilla(190),
           mul_ancilla15 => tpm_ancilla(191),
           mul_a0_out => tpm_ab_out(89),
           mul_a1_out => tpm_ab_out(90),
           mul_a2_out => tpm_ab_out(91),
           mul_a_sign_out => tpm_ab_out(92),
           mul_b0_out => tpm_ab_out(93),
           mul_b1_out => tpm_ab_out(94),
           mul_b2_out => tpm_ab_out(95),
           mul_b_sign_out => tpm_ab_out(96),
           mul_result0 => aybz(0),
           mul_result1 => aybz(1),
           mul_result2 => aybz(2),
           mul_result3 => aybz(3),
           mul_result4 => aybz(4),
           mul_result5 => aybz(5),
           mul_g0 => tpm_G(99),
           mul_g1 => tpm_G(100),
           mul_g2 => tpm_G(101),
           mul_g3 => tpm_G(102),
           mul_g4 => tpm_G(103),
           mul_g5 => tpm_G(104),
           mul_g6 => tpm_G(105),
           mul_g7 => tpm_G(106),
           mul_g8 => tpm_G(107),
           mul_sign_out => aybz_sign);

multiply_az_bw: TPM
port map ( mul_a0 => az(0),
           mul_a1 => az(1),
           mul_a2 => az(2),
			  mul_a_sign => az_sign,
			  mul_b0 => bw(0),
           mul_b1 => bw(1),
           mul_b2 => bw(2),
			  mul_b_sign => bw_sign,
           mul_ancilla0 => tpm_ancilla(192),
           mul_ancilla1 => tpm_ancilla(193),
           mul_ancilla2 => tpm_ancilla(194),
           mul_ancilla3 => tpm_ancilla(195),
           mul_ancilla4 => tpm_ancilla(196),
           mul_ancilla5 => tpm_ancilla(197),
           mul_ancilla6 => tpm_ancilla(198),
           mul_ancilla7 => tpm_ancilla(199),
           mul_ancilla8 => tpm_ancilla(200),
           mul_ancilla9 => tpm_ancilla(201),
           mul_ancilla10 => tpm_ancilla(202),
           mul_ancilla11 => tpm_ancilla(203),
           mul_ancilla12 => tpm_ancilla(204),
           mul_ancilla13 => tpm_ancilla(205),
           mul_ancilla14 => tpm_ancilla(206),
           mul_ancilla15 => tpm_ancilla(207),
           mul_a0_out => tpm_ab_out(97),
           mul_a1_out => tpm_ab_out(98),
           mul_a2_out => tpm_ab_out(99),
           mul_a_sign_out => tpm_ab_out(100),
           mul_b0_out => tpm_ab_out(101),
           mul_b1_out => tpm_ab_out(102),
           mul_b2_out => tpm_ab_out(103),
           mul_b_sign_out => tpm_ab_out(104),
           mul_result0 => azbw(0),
           mul_result1 => azbw(1),
           mul_result2 => azbw(2),
           mul_result3 => azbw(3),
           mul_result4 => azbw(4),
           mul_result5 => azbw(5),
           mul_g0 => tpm_G(108),
           mul_g1 => tpm_G(109),
           mul_g2 => tpm_G(110),
           mul_g3 => tpm_G(111),
           mul_g4 => tpm_G(112),
           mul_g5 => tpm_G(113),
           mul_g6 => tpm_G(114),
           mul_g7 => tpm_G(115),
           mul_g8 => tpm_G(116),
           mul_sign_out => azbw_sign);

multiply_az_bx: TPM
port map ( mul_a0 => az(0),
           mul_a1 => az(1),
           mul_a2 => az(2),
			  mul_a_sign => az_sign,
			  mul_b0 => bx(0),
           mul_b1 => bx(1),
           mul_b2 => bx(2),
			  mul_b_sign => bx_sign,
           mul_ancilla0 => tpm_ancilla(208),
           mul_ancilla1 => tpm_ancilla(209),
           mul_ancilla2 => tpm_ancilla(210),
           mul_ancilla3 => tpm_ancilla(211),
           mul_ancilla4 => tpm_ancilla(212),
           mul_ancilla5 => tpm_ancilla(213),
           mul_ancilla6 => tpm_ancilla(214),
           mul_ancilla7 => tpm_ancilla(215),
           mul_ancilla8 => tpm_ancilla(216),
           mul_ancilla9 => tpm_ancilla(217),
           mul_ancilla10 => tpm_ancilla(218),
           mul_ancilla11 => tpm_ancilla(219),
           mul_ancilla12 => tpm_ancilla(220),
           mul_ancilla13 => tpm_ancilla(221),
           mul_ancilla14 => tpm_ancilla(222),
           mul_ancilla15 => tpm_ancilla(223),
           mul_a0_out => tpm_ab_out(105),
           mul_a1_out => tpm_ab_out(106),
           mul_a2_out => tpm_ab_out(107),
           mul_a_sign_out => tpm_ab_out(108),
           mul_b0_out => tpm_ab_out(109),
           mul_b1_out => tpm_ab_out(110),
           mul_b2_out => tpm_ab_out(111),
           mul_b_sign_out => tpm_ab_out(112),
           mul_result0 => azbx(0),
           mul_result1 => azbx(1),
           mul_result2 => azbx(2),
           mul_result3 => azbx(3),
           mul_result4 => azbx(4),
           mul_result5 => azbx(5),
           mul_g0 => tpm_G(117),
           mul_g1 => tpm_G(118),
           mul_g2 => tpm_G(119),
           mul_g3 => tpm_G(120),
           mul_g4 => tpm_G(121),
           mul_g5 => tpm_G(122),
           mul_g6 => tpm_G(123),
           mul_g7 => tpm_G(124),
           mul_g8 => tpm_G(125),
           mul_sign_out => azbx_sign);

multiply_az_by: TPM
port map ( mul_a0 => az(0),
           mul_a1 => az(1),
           mul_a2 => az(2),
			  mul_a_sign => az_sign,
			  mul_b0 => by(0),
           mul_b1 => by(1),
           mul_b2 => by(2),
			  mul_b_sign => by_sign,
           mul_ancilla0 => tpm_ancilla(224),
           mul_ancilla1 => tpm_ancilla(225),
           mul_ancilla2 => tpm_ancilla(226),
           mul_ancilla3 => tpm_ancilla(227),
           mul_ancilla4 => tpm_ancilla(228),
           mul_ancilla5 => tpm_ancilla(229),
           mul_ancilla6 => tpm_ancilla(230),
           mul_ancilla7 => tpm_ancilla(231),
           mul_ancilla8 => tpm_ancilla(232),
           mul_ancilla9 => tpm_ancilla(233),
           mul_ancilla10 => tpm_ancilla(234),
           mul_ancilla11 => tpm_ancilla(235),
           mul_ancilla12 => tpm_ancilla(236),
           mul_ancilla13 => tpm_ancilla(237),
           mul_ancilla14 => tpm_ancilla(238),
           mul_ancilla15 => tpm_ancilla(239),
           mul_a0_out => tpm_ab_out(113),
           mul_a1_out => tpm_ab_out(114),
           mul_a2_out => tpm_ab_out(115),
           mul_a_sign_out => tpm_ab_out(116),
           mul_b0_out => tpm_ab_out(117),
           mul_b1_out => tpm_ab_out(118),
           mul_b2_out => tpm_ab_out(119),
           mul_b_sign_out => tpm_ab_out(120),
           mul_result0 => azby(0),
           mul_result1 => azby(1),
           mul_result2 => azby(2),
           mul_result3 => azby(3),
           mul_result4 => azby(4),
           mul_result5 => azby(5),
           mul_g0 => tpm_G(126),
           mul_g1 => tpm_G(127),
           mul_g2 => tpm_G(128),
           mul_g3 => tpm_G(129),
           mul_g4 => tpm_G(130),
           mul_g5 => tpm_G(131),
           mul_g6 => tpm_G(132),
           mul_g7 => tpm_G(133),
           mul_g8 => tpm_G(134),
           mul_sign_out => azby_sign);

multiply_az_bz: TPM
port map ( mul_a0 => az(0),
           mul_a1 => az(1),
           mul_a2 => az(2),
			  mul_a_sign => az_sign,
			  mul_b0 => bz(0),
           mul_b1 => bz(1),
           mul_b2 => bz(2),
			  mul_b_sign => bz_sign,
           mul_ancilla0 => tpm_ancilla(240),
           mul_ancilla1 => tpm_ancilla(241),
           mul_ancilla2 => tpm_ancilla(242),
           mul_ancilla3 => tpm_ancilla(243),
           mul_ancilla4 => tpm_ancilla(244),
           mul_ancilla5 => tpm_ancilla(245),
           mul_ancilla6 => tpm_ancilla(246),
           mul_ancilla7 => tpm_ancilla(247),
           mul_ancilla8 => tpm_ancilla(248),
           mul_ancilla9 => tpm_ancilla(249),
           mul_ancilla10 => tpm_ancilla(250),
           mul_ancilla11 => tpm_ancilla(251),
           mul_ancilla12 => tpm_ancilla(252),
           mul_ancilla13 => tpm_ancilla(253),
           mul_ancilla14 => tpm_ancilla(254),
           mul_ancilla15 => tpm_ancilla(255),
           mul_a0_out => tpm_ab_out(121),
           mul_a1_out => tpm_ab_out(122),
           mul_a2_out => tpm_ab_out(123),
           mul_a_sign_out => tpm_ab_out(124),
           mul_b0_out => tpm_ab_out(125),
           mul_b1_out => tpm_ab_out(126),
           mul_b2_out => tpm_ab_out(127),
           mul_b_sign_out => tpm_ab_out(128),
           mul_result0 => azbz(0),
           mul_result1 => azbz(1),
           mul_result2 => azbz(2),
           mul_result3 => azbz(3),
           mul_result4 => azbz(4),
           mul_result5 => azbz(5),
           mul_g0 => tpm_G(135),
           mul_g1 => tpm_G(136),
           mul_g2 => tpm_G(137),
           mul_g3 => tpm_G(138),
           mul_g4 => tpm_G(139),
           mul_g5 => tpm_G(140),
           mul_g6 => tpm_G(141),
           mul_g7 => tpm_G(142),
           mul_g8 => tpm_G(143),
           mul_sign_out => azbz_sign);

--------------------------------------- End of multiplication part | Start of addition/subtraction part
--
-- w = awbw - axbx - ayby - azbz = (awbw - axbx) - (ayby + azbz)
-- x = awbx + axbw + aybz - azby	= (awbx + axbw) + (aybz - azby)
-- y = awby + aybw + azbx - axbz	= (awby + aybw) + (azbx - axbz)
-- z = awbz + azbw + axby - aybx	= (awbz + azbw) + (axby - aybx)

---------------------------------------------------------CALCULATE w:
awbw_min_axbx: addsub3
Port map(  Ain(5 downto 0) => awbw,		   -- the adder/subtractor is made for 7 bit input,
			  Ain(6) => '0',						-- since the resulting multiplications (in this case, awbw)...
			  											-- ...is 6 bits, the 7th bit is made 0 (zero)
           SignFractialA => awbw_sign,
           SignVectorA => '0',
           Bin(5 downto 0) => axbx,			-- the same goes for the second input
			  Bin(6) => '0',
           SignFractialB => axbx_sign,
           SignVectorB => '1',

           Z1 => addsub_Z(1),					-- whole bunch of zeros
           Z2 => addsub_Z(2),
           Z3 => addsub_Z(3),
           Z4 => addsub_Z(4),
			  Z5 => addsub_Z(5),
           Z6 => addsub_Z(6),
			  Z7 => addsub_Z(7),
			  Z8 => addsub_Z(8),

			  TWOsIN1_Z1 => addsub_twosin1_Z(1),	 -- zeros for the 1st 2's complement block
			  TWOsIN1_Z2 => addsub_twosin1_Z(2),	 -- (The addsub3 has two 2's complement blocks in the inputs)
			  TWOsIN1_Z3 => addsub_twosin1_Z(3),
			  TWOsIN1_Z4 => addsub_twosin1_Z(4),
			  TWOsIN1_Z5 => addsub_twosin1_Z(5),

			  TWOsIN2_Z1 => addsub_twosin2_Z(1),	 -- zeros for the 2nd 2's complement block
			  TWOsIN2_Z2 => addsub_twosin2_Z(2),
			  TWOsIN2_Z3 => addsub_twosin2_Z(3),
			  TWOsIN2_Z4 => addsub_twosin2_Z(4),
			  TWOsIN2_Z5 => addsub_twosin2_Z(5),

			  TWOsOUT_Z1 => addsub_twosout_Z(1),	 -- zeros for the 2's complement block at the output
			  TWOsOUT_Z2 => addsub_twosout_Z(2),
			  TWOsOUT_Z3 => addsub_twosout_Z(3),
			  TWOsOUT_Z4 => addsub_twosout_Z(4),
			  TWOsOUT_Z5 => addsub_twosout_Z(5),
			  TWOsOUT_Z6 => addsub_twosout_Z(6),

			  G1 => addsub_G(1),
			  G2 => addsub_G(2),
			  G3 => addsub_G(3),
			  G4 => addsub_G(4),
			  G5 => addsub_G(5),
			  G6 => addsub_G(6),
			  G7 => addsub_G(7),
			  G8 => addsub_G(8),
			  G9 => addsub_G(9),
			  G10=> addsub_G(10),
			  G11=> addsub_G(11),
			  G12=> addsub_G(12),
			  G13=> addsub_G(13),
			  G14=> addsub_G(14),

			  TWOsIN1_G1 => addsub_twosin1_g(1),
			  TWOsIN1_G2 => addsub_twosin1_g(2),
			  TWOsIN1_G3 => addsub_twosin1_g(3),
			  TWOsIN1_G4 => addsub_twosin1_g(4),
			  TWOsIN1_G5 => addsub_twosin1_g(5),
			  TWOsIN1_G => addsub_twosin1_g(6),

			  TWOsIN2_G1 => addsub_twosin2_g(1),
			  TWOsIN2_G2 => addsub_twosin2_g(2),
			  TWOsIN2_G3 => addsub_twosin2_g(3),
			  TWOsIN2_G4 => addsub_twosin2_g(4),
			  TWOsIN2_G5 => addsub_twosin2_g(5),
			  TWOsIN2_G => addsub_twosin2_g(6),

			  TWOsOUT_G1 => addsub_twosout_g(1),
			  TWOsOUT_G2 => addsub_twosout_g(2),
			  TWOsOUT_G3 => addsub_twosout_g(3),
			  TWOsOUT_G4 => addsub_twosout_g(4),
			  TWOsOUT_G5 => addsub_twosout_g(5),
			  TWOsOUT_G6 => addsub_twosout_g(6),
			  TWOsOUT_G => addsub_twosout_g(7),

			  AddResult(6 downto 0) => awbw_min_axbx_result,  -- the result is 7 bits
			  AddResult(7) => zero,									  -- but the adder/subtractor has 8 bits results
			  																  -- so, the 8th bit is made to be 0 (zero) for now
			  SignVectorQ => awbw_min_axbx_result_sign);

ayby_plus_azbz: addsub3
Port map(  Ain(5 downto 0) => ayby,
			  Ain(6) => '0',
           SignFractialA => ayby_sign,
           SignVectorA => '0',
           Bin(5 downto 0) => azbz,
			  Bin(6) => '0',
           SignFractialB => azbz_sign,
           SignVectorB => '0',

           Z1 => addsub_Z(9),
           Z2 => addsub_Z(10),
           Z3 => addsub_Z(11),
           Z4 => addsub_Z(12),
			  Z5 => addsub_Z(13),
           Z6 => addsub_Z(14),
			  Z7 => addsub_Z(15),
			  Z8 => addsub_Z(16),

			  TWOsIN1_Z1 => addsub_twosin1_Z(6),
			  TWOsIN1_Z2 => addsub_twosin1_Z(7),
			  TWOsIN1_Z3 => addsub_twosin1_Z(8),
			  TWOsIN1_Z4 => addsub_twosin1_Z(9),
			  TWOsIN1_Z5 => addsub_twosin1_Z(10),

			  TWOsIN2_Z1 => addsub_twosin2_Z(6),
			  TWOsIN2_Z2 => addsub_twosin2_Z(7),
			  TWOsIN2_Z3 => addsub_twosin2_Z(8),
			  TWOsIN2_Z4 => addsub_twosin2_Z(9),
			  TWOsIN2_Z5 => addsub_twosin2_Z(10),

			  TWOsOUT_Z1 => addsub_twosout_Z(7),
			  TWOsOUT_Z2 => addsub_twosout_Z(8),
			  TWOsOUT_Z3 => addsub_twosout_Z(9),
			  TWOsOUT_Z4 => addsub_twosout_Z(10),
			  TWOsOUT_Z5 => addsub_twosout_Z(11),
			  TWOsOUT_Z6 => addsub_twosout_Z(12),

			  G1 => addsub_G(15),
			  G2 => addsub_G(16),
			  G3 => addsub_G(17),
			  G4 => addsub_G(18),
			  G5 => addsub_G(19),
			  G6 => addsub_G(20),
			  G7 => addsub_G(21),
			  G8 => addsub_G(22),
			  G9 => addsub_G(23),
			  G10=> addsub_G(24),
			  G11=> addsub_G(25),
			  G12=> addsub_G(26),
			  G13=> addsub_G(27),
			  G14=> addsub_G(28),

			  TWOsIN1_G1 => addsub_twosin1_g(7),
			  TWOsIN1_G2 => addsub_twosin1_g(8),
			  TWOsIN1_G3 => addsub_twosin1_g(9),
			  TWOsIN1_G4 => addsub_twosin1_g(10),
			  TWOsIN1_G5 => addsub_twosin1_g(11),
			  TWOsIN1_G => addsub_twosin1_g(12),

			  TWOsIN2_G1 => addsub_twosin2_g(7),
			  TWOsIN2_G2 => addsub_twosin2_g(8),
			  TWOsIN2_G3 => addsub_twosin2_g(9),
			  TWOsIN2_G4 => addsub_twosin2_g(10),
			  TWOsIN2_G5 => addsub_twosin2_g(11),
			  TWOsIN2_G => addsub_twosin2_g(12),

			  TWOsOUT_G1 => addsub_twosout_g(8),
			  TWOsOUT_G2 => addsub_twosout_g(9),
			  TWOsOUT_G3 => addsub_twosout_g(10),
			  TWOsOUT_G4 => addsub_twosout_g(11),
			  TWOsOUT_G5 => addsub_twosout_g(12),
			  TWOsOUT_G6 => addsub_twosout_g(13),
			  TWOsOUT_G => addsub_twosout_g(14),

			  AddResult(6 downto 0) => ayby_plus_azbz_result,
			  AddResult(7) => zero,
			  SignVectorQ => ayby_plus_azbz_result_sign);

w_is_awbw_min_axbx_min_ayby_min_azbz: addsub3
Port map(  Ain => awbw_min_axbx_result,					  -- here the inputs are 7 bits...
																		  -- so no more forcing 0 (zero) to the MSB (7th bit)
           SignFractialA => '0', 							  -- unused: awbw_min_axbx_result_sign,
           SignVectorA => '0',
           Bin => ayby_plus_azbz_result,
           SignFractialB => '0', 							  -- unused: ayby_plus_azbz_result_sign,
           SignVectorB => '1',

           Z1 => addsub_Z(17),
           Z2 => addsub_Z(18),
           Z3 => addsub_Z(19),
           Z4 => addsub_Z(20),
			  Z5 => addsub_Z(21),
           Z6 => addsub_Z(22),
			  Z7 => addsub_Z(23),
			  Z8 => addsub_Z(24),

			  TWOsIN1_Z1 => addsub_twosin1_Z(11),
			  TWOsIN1_Z2 => addsub_twosin1_Z(12),
			  TWOsIN1_Z3 => addsub_twosin1_Z(13),
			  TWOsIN1_Z4 => addsub_twosin1_Z(14),
			  TWOsIN1_Z5 => addsub_twosin1_Z(15),

			  TWOsIN2_Z1 => addsub_twosin2_Z(11),
			  TWOsIN2_Z2 => addsub_twosin2_Z(12),
			  TWOsIN2_Z3 => addsub_twosin2_Z(13),
			  TWOsIN2_Z4 => addsub_twosin2_Z(14),
			  TWOsIN2_Z5 => addsub_twosin2_Z(15),

			  TWOsOUT_Z1 => addsub_twosout_Z(13),
			  TWOsOUT_Z2 => addsub_twosout_Z(14),
			  TWOsOUT_Z3 => addsub_twosout_Z(15),
			  TWOsOUT_Z4 => addsub_twosout_Z(16),
			  TWOsOUT_Z5 => addsub_twosout_Z(17),
			  TWOsOUT_Z6 => addsub_twosout_Z(18),

			  G1 => addsub_G(29),
			  G2 => addsub_G(30),
			  G3 => addsub_G(31),
			  G4 => addsub_G(32),
			  G5 => addsub_G(33),
			  G6 => addsub_G(34),
			  G7 => addsub_G(35),
			  G8 => addsub_G(36),
			  G9 => addsub_G(37),
			  G10=> addsub_G(38),
			  G11=> addsub_G(39),
			  G12=> addsub_G(40),
			  G13=> addsub_G(41),
			  G14=> addsub_G(42),

			  TWOsIN1_G1 => addsub_twosin1_g(13),
			  TWOsIN1_G2 => addsub_twosin1_g(14),
			  TWOsIN1_G3 => addsub_twosin1_g(15),
			  TWOsIN1_G4 => addsub_twosin1_g(16),
			  TWOsIN1_G5 => addsub_twosin1_g(17),
			  TWOsIN1_G => addsub_twosin1_g(18),

			  TWOsIN2_G1 => addsub_twosin2_g(13),
			  TWOsIN2_G2 => addsub_twosin2_g(14),
			  TWOsIN2_G3 => addsub_twosin2_g(15),
			  TWOsIN2_G4 => addsub_twosin2_g(16),
			  TWOsIN2_G5 => addsub_twosin2_g(17),
			  TWOsIN2_G => addsub_twosin2_g(18),

			  TWOsOUT_G1 => addsub_twosout_g(15),
			  TWOsOUT_G2 => addsub_twosout_g(16),
			  TWOsOUT_G3 => addsub_twosout_g(17),
			  TWOsOUT_G4 => addsub_twosout_g(18),
			  TWOsOUT_G5 => addsub_twosout_g(19),
			  TWOsOUT_G6 => addsub_twosout_g(20),
			  TWOsOUT_G => addsub_twosout_g(21),

			  AddResult => w,			  				  -- here the result is already (assumed to be) 8 bits...
			  												  -- ...since the inputs are already 7 bits each.
															  -- so no more forcing 0 (zero) to the MSB (8th bit)
			  SignVectorQ => w_sign);

---------------------------------------------------------CALCULATE x:
awbx_plus_axbw: addsub3
Port map(  Ain(5 downto 0) => awbx,
			  Ain(6) => '0',
           SignFractialA => awbx_sign,
           SignVectorA => '0',
           Bin(5 downto 0) => axbw,
			  Bin(6) => '0',
           SignFractialB => axbw_sign,
           SignVectorB => '0',

           Z1 => addsub_Z(25),
           Z2 => addsub_Z(26),
           Z3 => addsub_Z(27),
           Z4 => addsub_Z(28),
			  Z5 => addsub_Z(29),
           Z6 => addsub_Z(30),
			  Z7 => addsub_Z(31),
			  Z8 => addsub_Z(32),

			  TWOsIN1_Z1 => addsub_twosin1_Z(16),
			  TWOsIN1_Z2 => addsub_twosin1_Z(17),
			  TWOsIN1_Z3 => addsub_twosin1_Z(18),
			  TWOsIN1_Z4 => addsub_twosin1_Z(19),
			  TWOsIN1_Z5 => addsub_twosin1_Z(20),

			  TWOsIN2_Z1 => addsub_twosin2_Z(16),
			  TWOsIN2_Z2 => addsub_twosin2_Z(17),
			  TWOsIN2_Z3 => addsub_twosin2_Z(18),
			  TWOsIN2_Z4 => addsub_twosin2_Z(19),
			  TWOsIN2_Z5 => addsub_twosin2_Z(20),

			  TWOsOUT_Z1 => addsub_twosout_Z(19),
			  TWOsOUT_Z2 => addsub_twosout_Z(20),
			  TWOsOUT_Z3 => addsub_twosout_Z(21),
			  TWOsOUT_Z4 => addsub_twosout_Z(22),
			  TWOsOUT_Z5 => addsub_twosout_Z(23),
			  TWOsOUT_Z6 => addsub_twosout_Z(24),

			  G1 => addsub_G(43),
			  G2 => addsub_G(44),
			  G3 => addsub_G(45),
			  G4 => addsub_G(46),
			  G5 => addsub_G(47),
			  G6 => addsub_G(48),
			  G7 => addsub_G(49),
			  G8 => addsub_G(50),
			  G9 => addsub_G(51),
			  G10=> addsub_G(52),
			  G11=> addsub_G(53),
			  G12=> addsub_G(54),
			  G13=> addsub_G(55),
			  G14=> addsub_G(56),

			  TWOsIN1_G1 => addsub_twosin1_g(19),
			  TWOsIN1_G2 => addsub_twosin1_g(20),
			  TWOsIN1_G3 => addsub_twosin1_g(21),
			  TWOsIN1_G4 => addsub_twosin1_g(22),
			  TWOsIN1_G5 => addsub_twosin1_g(23),
			  TWOsIN1_G => addsub_twosin1_g(24),

			  TWOsIN2_G1 => addsub_twosin2_g(19),
			  TWOsIN2_G2 => addsub_twosin2_g(20),
			  TWOsIN2_G3 => addsub_twosin2_g(21),
			  TWOsIN2_G4 => addsub_twosin2_g(22),
			  TWOsIN2_G5 => addsub_twosin2_g(23),
			  TWOsIN2_G => addsub_twosin2_g(24),

			  TWOsOUT_G1 => addsub_twosout_g(22),
			  TWOsOUT_G2 => addsub_twosout_g(23),
			  TWOsOUT_G3 => addsub_twosout_g(24),
			  TWOsOUT_G4 => addsub_twosout_g(25),
			  TWOsOUT_G5 => addsub_twosout_g(26),
			  TWOsOUT_G6 => addsub_twosout_g(27),
			  TWOsOUT_G => addsub_twosout_g(28),

			  AddResult(6 downto 0) => awbx_plus_axbw_result,
			  AddResult(7) => zero,
			  SignVectorQ => awbx_plus_axbw_result_sign);

aybz_min_azby: addsub3
Port map(  Ain(5 downto 0) => aybz,
			  Ain(6) => '0',
           SignFractialA => aybz_sign,
           SignVectorA => '0',
           Bin(5 downto 0) => azby,
			  Bin(6) => '0',
           SignFractialB => azby_sign,
           SignVectorB => '1',

           Z1 => addsub_Z(33),
           Z2 => addsub_Z(34),
           Z3 => addsub_Z(35),
           Z4 => addsub_Z(36),
			  Z5 => addsub_Z(37),
           Z6 => addsub_Z(38),
			  Z7 => addsub_Z(39),
			  Z8 => addsub_Z(40),

			  TWOsIN1_Z1 => addsub_twosin1_Z(21),
			  TWOsIN1_Z2 => addsub_twosin1_Z(22),
			  TWOsIN1_Z3 => addsub_twosin1_Z(23),
			  TWOsIN1_Z4 => addsub_twosin1_Z(24),
			  TWOsIN1_Z5 => addsub_twosin1_Z(25),

			  TWOsIN2_Z1 => addsub_twosin2_Z(21),
			  TWOsIN2_Z2 => addsub_twosin2_Z(22),
			  TWOsIN2_Z3 => addsub_twosin2_Z(23),
			  TWOsIN2_Z4 => addsub_twosin2_Z(24),
			  TWOsIN2_Z5 => addsub_twosin2_Z(25),

			  TWOsOUT_Z1 => addsub_twosout_Z(25),
			  TWOsOUT_Z2 => addsub_twosout_Z(26),
			  TWOsOUT_Z3 => addsub_twosout_Z(27),
			  TWOsOUT_Z4 => addsub_twosout_Z(28),
			  TWOsOUT_Z5 => addsub_twosout_Z(29),
			  TWOsOUT_Z6 => addsub_twosout_Z(30),

			  G1 => addsub_G(57),
			  G2 => addsub_G(58),
			  G3 => addsub_G(59),
			  G4 => addsub_G(60),
			  G5 => addsub_G(61),
			  G6 => addsub_G(62),
			  G7 => addsub_G(63),
			  G8 => addsub_G(64),
			  G9 => addsub_G(65),
			  G10=> addsub_G(66),
			  G11=> addsub_G(67),
			  G12=> addsub_G(68),
			  G13=> addsub_G(69),
			  G14=> addsub_G(70),

			  TWOsIN1_G1 => addsub_twosin1_g(25),
			  TWOsIN1_G2 => addsub_twosin1_g(26),
			  TWOsIN1_G3 => addsub_twosin1_g(27),
			  TWOsIN1_G4 => addsub_twosin1_g(28),
			  TWOsIN1_G5 => addsub_twosin1_g(29),
			  TWOsIN1_G => addsub_twosin1_g(30),

			  TWOsIN2_G1 => addsub_twosin2_g(25),
			  TWOsIN2_G2 => addsub_twosin2_g(26),
			  TWOsIN2_G3 => addsub_twosin2_g(27),
			  TWOsIN2_G4 => addsub_twosin2_g(28),
			  TWOsIN2_G5 => addsub_twosin2_g(29),
			  TWOsIN2_G => addsub_twosin2_g(30),

			  TWOsOUT_G1 => addsub_twosout_g(29),
			  TWOsOUT_G2 => addsub_twosout_g(30),
			  TWOsOUT_G3 => addsub_twosout_g(31),
			  TWOsOUT_G4 => addsub_twosout_g(32),
			  TWOsOUT_G5 => addsub_twosout_g(33),
			  TWOsOUT_G6 => addsub_twosout_g(34),
			  TWOsOUT_G => addsub_twosout_g(35),

			  AddResult(6 downto 0) => aybz_min_azby_result,
			  AddResult(7) => zero,
			  SignVectorQ => aybz_min_azby_result_sign);

x_is_awbx_plus_axbw_plus_aybz_min_azby: addsub3
Port map(  Ain => awbx_plus_axbw_result,
           SignFractialA => '0',										-- unused: awbx_plus_axbw_result_sign,
           SignVectorA => '0',
           Bin => aybz_min_azby_result,
           SignFractialB => '0',										-- unused: aybz_min_azby_result_sign,
           SignVectorB => '0',

           Z1 => addsub_Z(41),
           Z2 => addsub_Z(42),
           Z3 => addsub_Z(43),
           Z4 => addsub_Z(44),
			  Z5 => addsub_Z(45),
           Z6 => addsub_Z(46),
			  Z7 => addsub_Z(47),
			  Z8 => addsub_Z(48),

			  TWOsIN1_Z1 => addsub_twosin1_Z(26),
			  TWOsIN1_Z2 => addsub_twosin1_Z(27),
			  TWOsIN1_Z3 => addsub_twosin1_Z(28),
			  TWOsIN1_Z4 => addsub_twosin1_Z(29),
			  TWOsIN1_Z5 => addsub_twosin1_Z(30),

			  TWOsIN2_Z1 => addsub_twosin2_Z(26),
			  TWOsIN2_Z2 => addsub_twosin2_Z(27),
			  TWOsIN2_Z3 => addsub_twosin2_Z(28),
			  TWOsIN2_Z4 => addsub_twosin2_Z(29),
			  TWOsIN2_Z5 => addsub_twosin2_Z(30),

			  TWOsOUT_Z1 => addsub_twosout_Z(31),
			  TWOsOUT_Z2 => addsub_twosout_Z(32),
			  TWOsOUT_Z3 => addsub_twosout_Z(33),
			  TWOsOUT_Z4 => addsub_twosout_Z(34),
			  TWOsOUT_Z5 => addsub_twosout_Z(35),
			  TWOsOUT_Z6 => addsub_twosout_Z(36),

			  G1 => addsub_G(71),
			  G2 => addsub_G(72),
			  G3 => addsub_G(73),
			  G4 => addsub_G(74),
			  G5 => addsub_G(75),
			  G6 => addsub_G(76),
			  G7 => addsub_G(77),
			  G8 => addsub_G(78),
			  G9 => addsub_G(79),
			  G10=> addsub_G(80),
			  G11=> addsub_G(81),
			  G12=> addsub_G(82),
			  G13=> addsub_G(83),
			  G14=> addsub_G(84),

			  TWOsIN1_G1 => addsub_twosin1_g(31),
			  TWOsIN1_G2 => addsub_twosin1_g(32),
			  TWOsIN1_G3 => addsub_twosin1_g(33),
			  TWOsIN1_G4 => addsub_twosin1_g(34),
			  TWOsIN1_G5 => addsub_twosin1_g(35),
			  TWOsIN1_G => addsub_twosin1_g(36),

			  TWOsIN2_G1 => addsub_twosin2_g(31),
			  TWOsIN2_G2 => addsub_twosin2_g(32),
			  TWOsIN2_G3 => addsub_twosin2_g(33),
			  TWOsIN2_G4 => addsub_twosin2_g(34),
			  TWOsIN2_G5 => addsub_twosin2_g(35),
			  TWOsIN2_G => addsub_twosin2_g(36),

			  TWOsOUT_G1 => addsub_twosout_g(36),
			  TWOsOUT_G2 => addsub_twosout_g(37),
			  TWOsOUT_G3 => addsub_twosout_g(38),
			  TWOsOUT_G4 => addsub_twosout_g(39),
			  TWOsOUT_G5 => addsub_twosout_g(40),
			  TWOsOUT_G6 => addsub_twosout_g(41),
			  TWOsOUT_G => addsub_twosout_g(42),

			  AddResult => x,			  
			  SignVectorQ => x_sign);

---------------------------------------------------------CALCULATE y:
awby_plus_aybw: addsub3
Port map(  Ain(5 downto 0) => awby,
			  Ain(6) => '0',
           SignFractialA => awby_sign,
           SignVectorA => '0',
           Bin(5 downto 0) => aybw,
			  Bin(6) => '0',
           SignFractialB => aybw_sign,
           SignVectorB => '0',

           Z1 => addsub_Z(49),
           Z2 => addsub_Z(50),
           Z3 => addsub_Z(51),
           Z4 => addsub_Z(52),
			  Z5 => addsub_Z(53),
           Z6 => addsub_Z(54),
			  Z7 => addsub_Z(55),
			  Z8 => addsub_Z(56),

			  TWOsIN1_Z1 => addsub_twosin1_Z(31),
			  TWOsIN1_Z2 => addsub_twosin1_Z(32),
			  TWOsIN1_Z3 => addsub_twosin1_Z(33),
			  TWOsIN1_Z4 => addsub_twosin1_Z(34),
			  TWOsIN1_Z5 => addsub_twosin1_Z(35),

			  TWOsIN2_Z1 => addsub_twosin2_Z(31),
			  TWOsIN2_Z2 => addsub_twosin2_Z(32),
			  TWOsIN2_Z3 => addsub_twosin2_Z(33),
			  TWOsIN2_Z4 => addsub_twosin2_Z(34),
			  TWOsIN2_Z5 => addsub_twosin2_Z(35),

			  TWOsOUT_Z1 => addsub_twosout_Z(37),
			  TWOsOUT_Z2 => addsub_twosout_Z(38),
			  TWOsOUT_Z3 => addsub_twosout_Z(39),
			  TWOsOUT_Z4 => addsub_twosout_Z(40),
			  TWOsOUT_Z5 => addsub_twosout_Z(41),
			  TWOsOUT_Z6 => addsub_twosout_Z(42),

			  G1 => addsub_G(85),
			  G2 => addsub_G(86),
			  G3 => addsub_G(87),
			  G4 => addsub_G(88),
			  G5 => addsub_G(89),
			  G6 => addsub_G(90),
			  G7 => addsub_G(91),
			  G8 => addsub_G(92),
			  G9 => addsub_G(93),
			  G10=> addsub_G(94),
			  G11=> addsub_G(95),
			  G12=> addsub_G(96),
			  G13=> addsub_G(97),
			  G14=> addsub_G(98),

			  TWOsIN1_G1 => addsub_twosin1_g(37),
			  TWOsIN1_G2 => addsub_twosin1_g(38),
			  TWOsIN1_G3 => addsub_twosin1_g(39),
			  TWOsIN1_G4 => addsub_twosin1_g(40),
			  TWOsIN1_G5 => addsub_twosin1_g(41),
			  TWOsIN1_G => addsub_twosin1_g(42),

			  TWOsIN2_G1 => addsub_twosin2_g(37),
			  TWOsIN2_G2 => addsub_twosin2_g(38),
			  TWOsIN2_G3 => addsub_twosin2_g(39),
			  TWOsIN2_G4 => addsub_twosin2_g(40),
			  TWOsIN2_G5 => addsub_twosin2_g(41),
			  TWOsIN2_G => addsub_twosin2_g(42),

			  TWOsOUT_G1 => addsub_twosout_g(43),
			  TWOsOUT_G2 => addsub_twosout_g(44),
			  TWOsOUT_G3 => addsub_twosout_g(45),
			  TWOsOUT_G4 => addsub_twosout_g(46),
			  TWOsOUT_G5 => addsub_twosout_g(47),
			  TWOsOUT_G6 => addsub_twosout_g(48),
			  TWOsOUT_G => addsub_twosout_g(49),

			  AddResult(6 downto 0) => awby_plus_aybw_result,
			  AddResult(7) => zero,
			  SignVectorQ => awby_plus_aybw_result_sign);

azbx_min_axbz: addsub3
Port map(  Ain(5 downto 0) => azbx,
			  Ain(6) => '0',
           SignFractialA => azbx_sign,
           SignVectorA => '0',
           Bin(5 downto 0) => axbz,
			  Bin(6) => '0',
           SignFractialB => axbz_sign,
           SignVectorB => '1',

           Z1 => addsub_Z(57),
           Z2 => addsub_Z(58),
           Z3 => addsub_Z(59),
           Z4 => addsub_Z(60),
			  Z5 => addsub_Z(61),
           Z6 => addsub_Z(62),
			  Z7 => addsub_Z(63),
			  Z8 => addsub_Z(64),

			  TWOsIN1_Z1 => addsub_twosin1_Z(36),
			  TWOsIN1_Z2 => addsub_twosin1_Z(37),
			  TWOsIN1_Z3 => addsub_twosin1_Z(38),
			  TWOsIN1_Z4 => addsub_twosin1_Z(39),
			  TWOsIN1_Z5 => addsub_twosin1_Z(40),

			  TWOsIN2_Z1 => addsub_twosin2_Z(36),
			  TWOsIN2_Z2 => addsub_twosin2_Z(37),
			  TWOsIN2_Z3 => addsub_twosin2_Z(38),
			  TWOsIN2_Z4 => addsub_twosin2_Z(39),
			  TWOsIN2_Z5 => addsub_twosin2_Z(40),

			  TWOsOUT_Z1 => addsub_twosout_Z(43),
			  TWOsOUT_Z2 => addsub_twosout_Z(44),
			  TWOsOUT_Z3 => addsub_twosout_Z(45),
			  TWOsOUT_Z4 => addsub_twosout_Z(46),
			  TWOsOUT_Z5 => addsub_twosout_Z(47),
			  TWOsOUT_Z6 => addsub_twosout_Z(48),

			  G1 => addsub_G(99),
			  G2 => addsub_G(100),
			  G3 => addsub_G(101),
			  G4 => addsub_G(102),
			  G5 => addsub_G(103),
			  G6 => addsub_G(104),
			  G7 => addsub_G(105),
			  G8 => addsub_G(106),
			  G9 => addsub_G(107),
			  G10=> addsub_G(108),
			  G11=> addsub_G(109),
			  G12=> addsub_G(110),
			  G13=> addsub_G(111),
			  G14=> addsub_G(112),

			  TWOsIN1_G1 => addsub_twosin1_g(43),
			  TWOsIN1_G2 => addsub_twosin1_g(44),
			  TWOsIN1_G3 => addsub_twosin1_g(45),
			  TWOsIN1_G4 => addsub_twosin1_g(46),
			  TWOsIN1_G5 => addsub_twosin1_g(47),
			  TWOsIN1_G => addsub_twosin1_g(48),

			  TWOsIN2_G1 => addsub_twosin2_g(43),
			  TWOsIN2_G2 => addsub_twosin2_g(44),
			  TWOsIN2_G3 => addsub_twosin2_g(45),
			  TWOsIN2_G4 => addsub_twosin2_g(46),
			  TWOsIN2_G5 => addsub_twosin2_g(47),
			  TWOsIN2_G => addsub_twosin2_g(48),

			  TWOsOUT_G1 => addsub_twosout_g(50),
			  TWOsOUT_G2 => addsub_twosout_g(51),
			  TWOsOUT_G3 => addsub_twosout_g(52),
			  TWOsOUT_G4 => addsub_twosout_g(53),
			  TWOsOUT_G5 => addsub_twosout_g(54),
			  TWOsOUT_G6 => addsub_twosout_g(55),
			  TWOsOUT_G => addsub_twosout_g(56),

			  AddResult(6 downto 0) => azbx_min_axbz_result,
			  AddResult(7) => zero,
			  SignVectorQ => azbx_min_axbz_result_sign);

y_is_awby_plus_aybw_plus_azbx_min_axbz: addsub3
Port map(  Ain => awby_plus_aybw_result,
           SignFractialA => '0',										-- unused: awby_plus_aybw_result_sign,
           SignVectorA => '0',
           Bin => azbx_min_axbz_result,
           SignFractialB => '0',										-- unused: azbx_min_axbz_result_sign,
           SignVectorB => '0',

           Z1 => addsub_Z(65),
           Z2 => addsub_Z(66),
           Z3 => addsub_Z(67),
           Z4 => addsub_Z(68),
			  Z5 => addsub_Z(69),
           Z6 => addsub_Z(70),
			  Z7 => addsub_Z(71),
			  Z8 => addsub_Z(72),

			  TWOsIN1_Z1 => addsub_twosin1_Z(41),
			  TWOsIN1_Z2 => addsub_twosin1_Z(42),
			  TWOsIN1_Z3 => addsub_twosin1_Z(43),
			  TWOsIN1_Z4 => addsub_twosin1_Z(44),
			  TWOsIN1_Z5 => addsub_twosin1_Z(45),

			  TWOsIN2_Z1 => addsub_twosin2_Z(41),
			  TWOsIN2_Z2 => addsub_twosin2_Z(42),
			  TWOsIN2_Z3 => addsub_twosin2_Z(43),
			  TWOsIN2_Z4 => addsub_twosin2_Z(44),
			  TWOsIN2_Z5 => addsub_twosin2_Z(45),

			  TWOsOUT_Z1 => addsub_twosout_Z(49),
			  TWOsOUT_Z2 => addsub_twosout_Z(50),
			  TWOsOUT_Z3 => addsub_twosout_Z(51),
			  TWOsOUT_Z4 => addsub_twosout_Z(52),
			  TWOsOUT_Z5 => addsub_twosout_Z(53),
			  TWOsOUT_Z6 => addsub_twosout_Z(54),

			  G1 => addsub_G(113),
			  G2 => addsub_G(114),
			  G3 => addsub_G(115),
			  G4 => addsub_G(116),
			  G5 => addsub_G(117),
			  G6 => addsub_G(118),
			  G7 => addsub_G(119),
			  G8 => addsub_G(120),
			  G9 => addsub_G(121),
			  G10=> addsub_G(122),
			  G11=> addsub_G(123),
			  G12=> addsub_G(124),
			  G13=> addsub_G(125),
			  G14=> addsub_G(126),

			  TWOsIN1_G1 => addsub_twosin1_g(49),
			  TWOsIN1_G2 => addsub_twosin1_g(50),
			  TWOsIN1_G3 => addsub_twosin1_g(51),
			  TWOsIN1_G4 => addsub_twosin1_g(52),
			  TWOsIN1_G5 => addsub_twosin1_g(53),
			  TWOsIN1_G => addsub_twosin1_g(54),

			  TWOsIN2_G1 => addsub_twosin2_g(49),
			  TWOsIN2_G2 => addsub_twosin2_g(50),
			  TWOsIN2_G3 => addsub_twosin2_g(51),
			  TWOsIN2_G4 => addsub_twosin2_g(52),
			  TWOsIN2_G5 => addsub_twosin2_g(53),
			  TWOsIN2_G => addsub_twosin2_g(54),

			  TWOsOUT_G1 => addsub_twosout_g(57),
			  TWOsOUT_G2 => addsub_twosout_g(58),
			  TWOsOUT_G3 => addsub_twosout_g(59),
			  TWOsOUT_G4 => addsub_twosout_g(60),
			  TWOsOUT_G5 => addsub_twosout_g(61),
			  TWOsOUT_G6 => addsub_twosout_g(62),
			  TWOsOUT_G => addsub_twosout_g(63),

			  AddResult => y,			  
			  SignVectorQ => y_sign);

---------------------------------------------------------CALCULATE z:
awbz_plus_azbw: addsub3
Port map(  Ain(5 downto 0) => awbz,
			  Ain(6) => '0',
           SignFractialA => awbz_sign,
           SignVectorA => '0',
           Bin(5 downto 0) => azbw,
			  Bin(6) => '0',
           SignFractialB => azbw_sign,
           SignVectorB => '0',

           Z1 => addsub_Z(73),
           Z2 => addsub_Z(74),
           Z3 => addsub_Z(75),
           Z4 => addsub_Z(76),
			  Z5 => addsub_Z(77),
           Z6 => addsub_Z(78),
			  Z7 => addsub_Z(79),
			  Z8 => addsub_Z(80),

			  TWOsIN1_Z1 => addsub_twosin1_Z(46),
			  TWOsIN1_Z2 => addsub_twosin1_Z(47),
			  TWOsIN1_Z3 => addsub_twosin1_Z(48),
			  TWOsIN1_Z4 => addsub_twosin1_Z(49),
			  TWOsIN1_Z5 => addsub_twosin1_Z(50),

			  TWOsIN2_Z1 => addsub_twosin2_Z(46),
			  TWOsIN2_Z2 => addsub_twosin2_Z(47),
			  TWOsIN2_Z3 => addsub_twosin2_Z(48),
			  TWOsIN2_Z4 => addsub_twosin2_Z(49),
			  TWOsIN2_Z5 => addsub_twosin2_Z(50),

			  TWOsOUT_Z1 => addsub_twosout_Z(55),
			  TWOsOUT_Z2 => addsub_twosout_Z(56),
			  TWOsOUT_Z3 => addsub_twosout_Z(57),
			  TWOsOUT_Z4 => addsub_twosout_Z(58),
			  TWOsOUT_Z5 => addsub_twosout_Z(59),
			  TWOsOUT_Z6 => addsub_twosout_Z(60),

			  G1 => addsub_G(127),
			  G2 => addsub_G(128),
			  G3 => addsub_G(129),
			  G4 => addsub_G(130),
			  G5 => addsub_G(131),
			  G6 => addsub_G(132),
			  G7 => addsub_G(133),
			  G8 => addsub_G(134),
			  G9 => addsub_G(135),
			  G10=> addsub_G(136),
			  G11=> addsub_G(137),
			  G12=> addsub_G(138),
			  G13=> addsub_G(139),
			  G14=> addsub_G(140),

			  TWOsIN1_G1 => addsub_twosin1_g(55),
			  TWOsIN1_G2 => addsub_twosin1_g(56),
			  TWOsIN1_G3 => addsub_twosin1_g(57),
			  TWOsIN1_G4 => addsub_twosin1_g(58),
			  TWOsIN1_G5 => addsub_twosin1_g(59),
			  TWOsIN1_G => addsub_twosin1_g(60),

			  TWOsIN2_G1 => addsub_twosin2_g(55),
			  TWOsIN2_G2 => addsub_twosin2_g(56),
			  TWOsIN2_G3 => addsub_twosin2_g(57),
			  TWOsIN2_G4 => addsub_twosin2_g(58),
			  TWOsIN2_G5 => addsub_twosin2_g(59),
			  TWOsIN2_G => addsub_twosin2_g(60),

			  TWOsOUT_G1 => addsub_twosout_g(64),
			  TWOsOUT_G2 => addsub_twosout_g(65),
			  TWOsOUT_G3 => addsub_twosout_g(66),
			  TWOsOUT_G4 => addsub_twosout_g(67),
			  TWOsOUT_G5 => addsub_twosout_g(68),
			  TWOsOUT_G6 => addsub_twosout_g(69),
			  TWOsOUT_G => addsub_twosout_g(70),

			  AddResult(6 downto 0) => awbz_plus_azbw_result,
			  AddResult(7) => zero,
			  SignVectorQ => awbz_plus_azbw_result_sign);

axby_min_aybx: addsub3
Port map(  Ain(5 downto 0) => axby,
			  Ain(6) => '0',
           SignFractialA => axby_sign,
           SignVectorA => '0',
           Bin(5 downto 0) => aybx,
			  Bin(6) => '0',
           SignFractialB => aybx_sign,
           SignVectorB => '1',

           Z1 => addsub_Z(81),
           Z2 => addsub_Z(82),
           Z3 => addsub_Z(83),
           Z4 => addsub_Z(84),
			  Z5 => addsub_Z(85),
           Z6 => addsub_Z(86),
			  Z7 => addsub_Z(87),
			  Z8 => addsub_Z(88),

			  TWOsIN1_Z1 => addsub_twosin1_Z(51),
			  TWOsIN1_Z2 => addsub_twosin1_Z(52),
			  TWOsIN1_Z3 => addsub_twosin1_Z(53),
			  TWOsIN1_Z4 => addsub_twosin1_Z(54),
			  TWOsIN1_Z5 => addsub_twosin1_Z(55),

			  TWOsIN2_Z1 => addsub_twosin2_Z(51),
			  TWOsIN2_Z2 => addsub_twosin2_Z(52),
			  TWOsIN2_Z3 => addsub_twosin2_Z(53),
			  TWOsIN2_Z4 => addsub_twosin2_Z(54),
			  TWOsIN2_Z5 => addsub_twosin2_Z(55),

			  TWOsOUT_Z1 => addsub_twosout_Z(61),
			  TWOsOUT_Z2 => addsub_twosout_Z(62),
			  TWOsOUT_Z3 => addsub_twosout_Z(63),
			  TWOsOUT_Z4 => addsub_twosout_Z(64),
			  TWOsOUT_Z5 => addsub_twosout_Z(65),
			  TWOsOUT_Z6 => addsub_twosout_Z(66),

			  G1 => addsub_G(141),
			  G2 => addsub_G(142),
			  G3 => addsub_G(143),
			  G4 => addsub_G(144),
			  G5 => addsub_G(145),
			  G6 => addsub_G(146),
			  G7 => addsub_G(147),
			  G8 => addsub_G(148),
			  G9 => addsub_G(149),
			  G10=> addsub_G(150),
			  G11=> addsub_G(151),
			  G12=> addsub_G(152),
			  G13=> addsub_G(153),
			  G14=> addsub_G(154),

			  TWOsIN1_G1 => addsub_twosin1_g(61),
			  TWOsIN1_G2 => addsub_twosin1_g(62),
			  TWOsIN1_G3 => addsub_twosin1_g(63),
			  TWOsIN1_G4 => addsub_twosin1_g(64),
			  TWOsIN1_G5 => addsub_twosin1_g(65),
			  TWOsIN1_G => addsub_twosin1_g(66),

			  TWOsIN2_G1 => addsub_twosin2_g(61),
			  TWOsIN2_G2 => addsub_twosin2_g(62),
			  TWOsIN2_G3 => addsub_twosin2_g(63),
			  TWOsIN2_G4 => addsub_twosin2_g(64),
			  TWOsIN2_G5 => addsub_twosin2_g(65),
			  TWOsIN2_G => addsub_twosin2_g(66),

			  TWOsOUT_G1 => addsub_twosout_g(71),
			  TWOsOUT_G2 => addsub_twosout_g(72),
			  TWOsOUT_G3 => addsub_twosout_g(73),
			  TWOsOUT_G4 => addsub_twosout_g(74),
			  TWOsOUT_G5 => addsub_twosout_g(75),
			  TWOsOUT_G6 => addsub_twosout_g(76),
			  TWOsOUT_G => addsub_twosout_g(77),

			  AddResult(6 downto 0) => axby_min_aybx_result,
			  AddResult(7) => zero,
			  SignVectorQ => axby_min_aybx_result_sign);

z_is_awbz_plus_azbw_plus_axby_min_aybx: addsub3
Port map(  Ain => awbz_plus_azbw_result,
           SignFractialA => '0',											-- unused: awbz_plus_azbw_result_sign,
           SignVectorA => '0',
           Bin => axby_min_aybx_result,
           SignFractialB => '0',											-- unused: axby_min_aybx_result_sign,
           SignVectorB => '0',

           Z1 => addsub_Z(89),
           Z2 => addsub_Z(90),
           Z3 => addsub_Z(91),
           Z4 => addsub_Z(92),
			  Z5 => addsub_Z(93),
           Z6 => addsub_Z(94),
			  Z7 => addsub_Z(95),
			  Z8 => addsub_Z(96),

			  TWOsIN1_Z1 => addsub_twosin1_Z(56),
			  TWOsIN1_Z2 => addsub_twosin1_Z(57),
			  TWOsIN1_Z3 => addsub_twosin1_Z(58),
			  TWOsIN1_Z4 => addsub_twosin1_Z(59),
			  TWOsIN1_Z5 => addsub_twosin1_Z(60),

			  TWOsIN2_Z1 => addsub_twosin2_Z(56),
			  TWOsIN2_Z2 => addsub_twosin2_Z(57),
			  TWOsIN2_Z3 => addsub_twosin2_Z(58),
			  TWOsIN2_Z4 => addsub_twosin2_Z(59),
			  TWOsIN2_Z5 => addsub_twosin2_Z(60),

			  TWOsOUT_Z1 => addsub_twosout_Z(67),
			  TWOsOUT_Z2 => addsub_twosout_Z(68),
			  TWOsOUT_Z3 => addsub_twosout_Z(69),
			  TWOsOUT_Z4 => addsub_twosout_Z(70),
			  TWOsOUT_Z5 => addsub_twosout_Z(71),
			  TWOsOUT_Z6 => addsub_twosout_Z(72),

			  G1 => addsub_G(155),
			  G2 => addsub_G(156),
			  G3 => addsub_G(157),
			  G4 => addsub_G(158),
			  G5 => addsub_G(159),
			  G6 => addsub_G(160),
			  G7 => addsub_G(161),
			  G8 => addsub_G(162),
			  G9 => addsub_G(163),
			  G10=> addsub_G(164),
			  G11=> addsub_G(165),
			  G12=> addsub_G(166),
			  G13=> addsub_G(167),
			  G14=> addsub_G(168),

			  TWOsIN1_G1 => addsub_twosin1_g(67),
			  TWOsIN1_G2 => addsub_twosin1_g(68),
			  TWOsIN1_G3 => addsub_twosin1_g(69),
			  TWOsIN1_G4 => addsub_twosin1_g(70),
			  TWOsIN1_G5 => addsub_twosin1_g(71),
			  TWOsIN1_G => addsub_twosin1_g(72),

			  TWOsIN2_G1 => addsub_twosin2_g(67),
			  TWOsIN2_G2 => addsub_twosin2_g(68),
			  TWOsIN2_G3 => addsub_twosin2_g(69),
			  TWOsIN2_G4 => addsub_twosin2_g(70),
			  TWOsIN2_G5 => addsub_twosin2_g(71),
			  TWOsIN2_G => addsub_twosin2_g(72),

			  TWOsOUT_G1 => addsub_twosout_g(78),
			  TWOsOUT_G2 => addsub_twosout_g(79),
			  TWOsOUT_G3 => addsub_twosout_g(80),
			  TWOsOUT_G4 => addsub_twosout_g(81),
			  TWOsOUT_G5 => addsub_twosout_g(82),
			  TWOsOUT_G6 => addsub_twosout_g(83),
			  TWOsOUT_G => addsub_twosout_g(84),

			  AddResult => z,			  
			  SignVectorQ => z_sign);

end Behavioral;
